/////////////////////////////////////////////////////////////////////////////////
///  Bond ver.1.2  簡単な分子作成ソフト　2018.4　岩見沢農業高等学校　理科   ///
/////////////////////////////////////////////////////////////////////////////////
//---- 変数の定義----
PImage IMG_s1;  //PImageオブジェクト生成
PImage IMG_s2;
PImage IMG0;
PImage IMG1; 
PImage IMG2; 
PImage IMG3; 
PImage IMG4; 
PImage IMG5; 
PImage IMG6; 
PImage IMG7_1; 
PImage IMG7_2; 
PImage IMG8; 
PImage IMG9; 
PImage IMG10; 
PImage IMG11_1; 
PImage IMG11_2; 
PImage IMG12_1; 
PImage IMG12_2; 

boolean IMGboo;  //説明画像表示・非表示
PFont fontG12;  //PFontオブジェクト生成
PFont fontG18;  //PFontオブジェクト生成
PFont fontG25;  //PFontオブジェクト生成
PFont fontG35;  //PFontオブジェクト生成
PFont fontG45;  //PFontオブジェクト生成

//水素原子１
float H1X;
float H1Y;
float H1U1X;
float H1U1Y;
//水素原子２
float H2X;
float H2Y;
float H2U1X;
float H2U1Y;
//水素原子３
float H3X;
float H3Y;
float H3U1X;
float H3U1Y;   
//水素原子４
float H4X;
float H4Y;
float H4U1X;
float H4U1Y;
//水素原子５
float H5X;
float H5Y;
float H5U1X;
float H5U1Y;
//水素原子６
float H6X;
float H6Y;
float H6U1X;
float H6U1Y;
//酸素原子１
float O1X;
float O1Y;
float O1U1X;
float O1U1Y;
float O1U2X;
float O1U2Y;
//酸素原子２
float O2X;
float O2Y;
float O2U1X;
float O2U1Y;
float O2U2X;
float O2U2Y;
//窒素原子１
float N1X;
float N1Y;
float N1U1X;
float N1U1Y;
float N1U2X;
float N1U2Y;
float N1U3X;
float N1U3Y;
//窒素原子２
float N2X;
float N2Y;
float N2U1X;
float N2U1Y;
float N2U2X;
float N2U2Y;
float N2U3X;
float N2U3Y;
//炭素原子１
float C1X;
float C1Y;
float C1U1X;
float C1U1Y;
float C1U2X;
float C1U2Y;
float C1U3X;
float C1U3Y;
float C1U4X;
float C1U4Y;
//炭素原子２
float C2X;
float C2Y;
float C2U1X;
float C2U1Y;
float C2U2X;
float C2U2Y;
float C2U3X;
float C2U3Y;
float C2U4X;
float C2U4Y;

//腕の角度
float H1U1angle;
float H2U1angle;
float H3U1angle;
float H4U1angle;
float H5U1angle;
float H6U1angle;
float O1U1angle;
float O1U2angle;
float O2U1angle;
float O2U2angle;
float N1U1angle;
float N1U2angle;
float N1U3angle;
float N2U1angle;
float N2U2angle;
float N2U3angle;
float C1U1angle;
float C1U2angle;
float C1U3angle;
float C1U4angle;
float C2U1angle;
float C2U2angle;
float C2U3angle;
float C2U4angle;

//ブーレアン
boolean H1boo;
boolean H1U1boo;
boolean H2boo;
boolean H2U1boo;
boolean H3boo;
boolean H3U1boo;
boolean H4boo;
boolean H4U1boo;
boolean H5boo;
boolean H5U1boo;
boolean H6boo;
boolean H6U1boo;
boolean O1boo;
boolean O1U1boo;
boolean O1U2boo;
boolean O2boo;
boolean O2U1boo;
boolean O2U2boo;
boolean N1boo;
boolean N1U1boo;
boolean N1U2boo;
boolean N1U3boo;
boolean N2boo;
boolean N2U1boo;
boolean N2U2boo;
boolean N2U3boo;
boolean C1boo;
boolean C1U1boo;
boolean C1U2boo;
boolean C1U3boo;
boolean C1U4boo;
boolean C2boo;
boolean C2U1boo;
boolean C2U2boo;
boolean C2U3boo;
boolean C2U4boo;

//try
boolean try0;
boolean try1;
boolean try2;
boolean try3;
boolean try4;
boolean try5;
boolean try6;
boolean try7;
boolean try8;
boolean try9;
boolean try10;
boolean try11;
boolean try12;
boolean Akey;
boolean Zkey;

//tryOK
boolean try1OK;
boolean try2OK;
boolean try3OK;
boolean try4OK;
boolean try5OK;
boolean try6OK;
boolean try7OK;
boolean try8OK;
boolean try9OK;
boolean try10OK;
boolean try11OK;
boolean try12OK;

//bond
boolean H1U1bond;
boolean H2U1bond;
boolean H3U1bond;
boolean H4U1bond;
boolean H5U1bond;
boolean H6U1bond;

boolean O1U1bond;
boolean O1U2bond;
boolean O2U1bond;
boolean O2U2bond;

boolean N1U1bond;
boolean N1U2bond;
boolean N1U3bond;
boolean N2U1bond;
boolean N2U2bond;
boolean N2U3bond;

boolean C1U1bond;
boolean C1U2bond;
boolean C1U3bond;
boolean C1U4bond;
boolean C2U1bond;
boolean C2U2bond;
boolean C2U3bond;
boolean C2U4bond;

boolean HOlink;  //try7で２種類の分子の識別用
boolean try7img;  //try7で２種類の分子の画像切り替え用
boolean try11img;  //try11で２種類の画像切り替え用
boolean try12img;  //try12で２種類の画像切り替え用
float angle; //二重結合、三重結合整列用
int i; //try1等の文字サイズ変更用カウンター
int j; //try1での水素原子移動用カウンター
float conAng;  //try1で水素原子移動時の角度（定数）

void setup() {
  size(1000, 730);
  fontG12 = createFont("MS Gothic", 12, true);
  fontG18 = createFont("MS Gothic", 18, true); 
  fontG25 = createFont("MS Gothic", 25, true);
  fontG35 = createFont("MS Gothic", 35, true); 
  fontG45 = createFont("MS Gothic", 45, true); 
  shokiti();
  try0 = true;
  conAng = 0.6588618/180; //(90-104.5/2)=37.75度=0.6588618rad
  IMG_s1 = loadImage("data/bond.jpg");
  IMG_s2 = loadImage("data/OCbond.JPG");
  IMG0 = loadImage("data/try0.jpg"); 
  IMG1 = loadImage("data/try1.jpg"); 
  IMG2 = loadImage("data/try2.jpg"); 
  IMG3 = loadImage("data/try3.jpg"); 
  IMG4 = loadImage("data/try4.jpg"); 
  IMG5 = loadImage("data/try5.jpg"); 
  IMG6 = loadImage("data/try6.jpg"); 
  IMG7_1 = loadImage("data/try7_1.jpg"); 
  IMG7_2 = loadImage("data/try7_2.jpg"); 
  IMG8 = loadImage("data/try8.jpg"); 
  IMG9 = loadImage("data/try9.jpg"); 
  IMG10 = loadImage("data/try10.jpg");
  IMG11_1 = loadImage("data/try11_1.jpg"); 
  IMG11_2 = loadImage("data/try11_2.jpg"); 
  IMG12_1 = loadImage("data/try12_1.jpg"); 
  IMG12_2 = loadImage("data/try12_2.jpg");
}

void draw() { 

  background(0);

  //説明文等
  fill(255, 255, 255);   //文字の色を白に設定  
  textFont(fontG12);
  text("Bond ver.1.2  北海道岩見沢農業高等学校理科", 5, 10);
  textFont(fontG18); 
  text("構造式、分子模型等は〈A〉キーで表示・非表示", 600, 30); 
  textFont(fontG35); 
  fill(100, 200, 200);   //文字の色を水色に設定 
  text("分子を作ってみよう", 80, 50);

  button();  //ボタン表示関数呼び出し
  AZkey();  //Akey,Zkey表示関数呼び出し

  if (try0==false) {
    stroke(100, 100, 100);
    strokeWeight(1);
    line(600, 280, 600, 730);
    textFont(fontG18); 
    fill(200, 200, 200);   
    text("この線より左側が分子作成場所", 605, 720);
  }

  //初期画面の表示文等
  if (try0==true) {
    fill(255, 255, 255);   //文字の色を白に設定
    textFont(fontG25); 
    text("① 水素、酸素、窒素、炭素の各原子を組み合わせて共有結合分子を作る。", 120, 370); 
    text("② 各原子の中心をマウスでドラッグすると移動する。", 120, 420); 
    text("③ 各原子の〈共有結合の腕〉（価標）はマウスでドラッグすると回転する。", 120, 470); 
    text("④ 構造式、分子模型等は〈A〉キーで表示・非表示できる。", 120, 520); 
    text("この画面で動きを確認した後、画面の1～12のボタンを押すか、半角英数で", 120, 590); 
    text("〈1〉～〈0〉〈Q〉〈W〉キーを順番に押して分子作成にトライしてください。", 120, 630);
    textFont(fontG18);    
    text("途中でこの初期画面を出す場合はSボタンか〈S〉キーを押してください。", 120, 680);
    text("分子模型の画像はjmolを利用しています。", 120, 710);
    image(IMG_s1, 580, 80, 380, 107 );
    image(IMG_s2, 323, 255, 120, 60 );
    textFont(fontG12);    
    text("任意の腕の先をマ", 580, 205);    
    text("ウスでクリック・", 580, 230); 
    text("ドローして重ねる", 580, 255); 
    text("腕が自動的に並び", 720, 205); 
    text("二重結合準備状態", 720, 230);    
    text("になる", 720, 255);  
    text("更にもう一つの腕", 860, 205); 
    text("を重ねると自動的", 860, 230);    
    text("に三重結合になる", 860, 255); 
    textFont(fontG18);  
    text("（窒素原子や酸素原子でも同様の操作ができる）", 575, 300); 
    text("結合すると先端が光る", 140, 280); 
    textFont(fontG12);  
    text("（H1- O1, N1- C1等で確認可能）", 140, 305); 

    stroke(255, 255, 255);
    strokeWeight(1);
    line(560, 70, 980, 70); 
    line(560, 320, 980, 320);  
    line(980, 70, 980, 320);  
    line(560, 70, 560, 320);

    line(130, 245, 450, 245); 
    line(130, 320, 450, 320);  
    line(130, 245, 130, 320);  
    line(450, 245, 450, 320);
  }
  if (try0==false) {
    textFont(fontG18);
    text("（ 白 枠 内 の 原 子 を 使 う ）", 150, 260);
  }

  //マウスが押されている間、次の処理を行う
  if (mousePressed == true && mouseX>5 && mouseX<580 && mouseY>5  && mouseY <725) {     
    //水素１原子
    if (H1boo==true) {
      H1X = mouseX;
      H1Y = mouseY;
      H1U1X = H1X + 30*cos(H1U1angle);
      H1U1Y = H1Y + 30*sin(H1U1angle);
    }
    if (H1U1boo==true) {
      H1U1angle = atan2(mouseY-H1Y, mouseX-H1X);
      H1U1X = H1X + 30*cos(H1U1angle);
      H1U1Y = H1Y + 30*sin(H1U1angle);
    }
    //水素２原子
    if (H2boo==true) {
      H2X = mouseX;
      H2Y = mouseY;
      H2U1X = H2X + 30*cos(H2U1angle);
      H2U1Y = H2Y + 30*sin(H2U1angle);
    }
    if (H2U1boo==true) {
      H2U1angle = atan2(mouseY-H2Y, mouseX-H2X);
      H2U1X = H2X + 30*cos(H2U1angle);
      H2U1Y = H2Y + 30*sin(H2U1angle);
    }
    //水素３原子
    if (H3boo==true) {
      H3X = mouseX;
      H3Y = mouseY;
      H3U1X = H3X + 30*cos(H3U1angle);
      H3U1Y = H3Y + 30*sin(H3U1angle);
    }
    if (H3U1boo==true) {
      H3U1angle = atan2(mouseY-H3Y, mouseX-H3X);
      H3U1X = H3X + 30*cos(H3U1angle);
      H3U1Y = H3Y + 30*sin(H3U1angle);
    }
    //水素４原子
    if (H4boo==true) {
      H4X = mouseX;
      H4Y = mouseY;
      H4U1X = H4X + 30*cos(H4U1angle);
      H4U1Y = H4Y + 30*sin(H4U1angle);
    }
    if (H4U1boo==true) {
      H4U1angle = atan2(mouseY-H4Y, mouseX-H4X);
      H4U1X = H4X + 30*cos(H4U1angle);
      H4U1Y = H4Y + 30*sin(H4U1angle);
    }
    //水素５原子
    if (H5boo==true) {
      H5X = mouseX;
      H5Y = mouseY;
      H5U1X = H5X + 30*cos(H5U1angle);
      H5U1Y = H5Y + 30*sin(H5U1angle);
    }
    if (H5U1boo==true) {
      H5U1angle = atan2(mouseY-H5Y, mouseX-H5X);
      H5U1X = H5X + 30*cos(H5U1angle);
      H5U1Y = H5Y + 30*sin(H5U1angle);
    }
    //水素６原子
    if (H6boo==true) {
      H6X = mouseX;
      H6Y = mouseY;
      H6U1X = H6X + 30*cos(H6U1angle);
      H6U1Y = H6Y + 30*sin(H6U1angle);
    }
    if (H6U1boo==true) {
      H6U1angle = atan2(mouseY-H6Y, mouseX-H6X);
      H6U1X = H6X + 30*cos(H6U1angle);
      H6U1Y = H6Y + 30*sin(H6U1angle);
    }
    //酸素１原子
    if (O1boo==true) {
      O1X = mouseX;
      O1Y = mouseY;
      O1U1X = O1X + 40*cos(O1U1angle);
      O1U1Y = O1Y + 40*sin(O1U1angle);
      O1U2X = O1X + 40*cos(O1U2angle);
      O1U2Y = O1Y + 40*sin(O1U2angle);
    }
    if (O1U1boo==true) {
      O1U1angle = atan2(mouseY-O1Y, mouseX-O1X);
      O1U1X = O1X + 40*cos(O1U1angle);
      O1U1Y = O1Y + 40*sin(O1U1angle);
    }
    if (O1U2boo==true) {
      O1U2angle = atan2(mouseY-O1Y, mouseX-O1X);
      O1U2X = O1X + 40*cos(O1U2angle);
      O1U2Y = O1Y + 40*sin(O1U2angle);
    }
    //酸素２原子
    if (O2boo==true) {
      O2X = mouseX;
      O2Y = mouseY;
      O2U1X = O2X + 40*cos(O2U1angle);
      O2U1Y = O2Y + 40*sin(O2U1angle);
      O2U2X = O2X + 40*cos(O2U2angle);
      O2U2Y = O2Y + 40*sin(O2U2angle);
    }
    if (O2U1boo==true) {
      O2U1angle = atan2(mouseY-O2Y, mouseX-O2X);
      O2U1X = O2X + 40*cos(O2U1angle);
      O2U1Y = O2Y + 40*sin(O2U1angle);
    }
    if (O2U2boo==true) {
      O2U2angle = atan2(mouseY-O2Y, mouseX-O2X);
      O2U2X = O2X + 40*cos(O2U2angle);
      O2U2Y = O2Y + 40*sin(O2U2angle);
    }   
    //窒素１原子  
    if (N1boo==true) {
      N1X = mouseX;
      N1Y = mouseY;
      N1U1X = N1X + 40*cos(N1U1angle);
      N1U1Y = N1Y + 40*sin(N1U1angle);
      N1U2X = N1X + 40*cos(N1U2angle);
      N1U2Y = N1Y + 40*sin(N1U2angle);
      N1U3X = N1X + 40*cos(N1U3angle);
      N1U3Y = N1Y + 40*sin(N1U3angle);
    }
    if (N1U1boo==true) {
      N1U1angle = atan2(mouseY-N1Y, mouseX-N1X);
      N1U1X = N1X + 40*cos(N1U1angle);
      N1U1Y = N1Y + 40*sin(N1U1angle);
    }
    if (N1U2boo==true) {
      N1U2angle = atan2(mouseY-N1Y, mouseX-N1X);
      N1U2X = N1X + 40*cos(N1U2angle);
      N1U2Y = N1Y + 40*sin(N1U2angle);
    }
    if (N1U3boo==true) {
      N1U3angle = atan2(mouseY-N1Y, mouseX-N1X);
      N1U3X = N1X + 40*cos(N1U3angle);
      N1U3Y = N1Y + 40*sin(N1U3angle);
    }  
    //窒素２原子  
    if (N2boo==true) {
      N2X = mouseX;
      N2Y = mouseY;
      N2U1X = N2X + 40*cos(N2U1angle);
      N2U1Y = N2Y + 40*sin(N2U1angle);
      N2U2X = N2X + 40*cos(N2U2angle);
      N2U2Y = N2Y + 40*sin(N2U2angle);
      N2U3X = N2X + 40*cos(N2U3angle);
      N2U3Y = N2Y + 40*sin(N2U3angle);
    }
    if (N2U1boo==true) {
      N2U1angle = atan2(mouseY-N2Y, mouseX-N2X);
      N2U1X = N2X + 40*cos(N2U1angle);
      N2U1Y = N2Y + 40*sin(N2U1angle);
    }
    if (N2U2boo==true) {
      N2U2angle = atan2(mouseY-N2Y, mouseX-N2X);
      N2U2X = N2X + 40*cos(N2U2angle);
      N2U2Y = N2Y + 40*sin(N2U2angle);
    }
    if (N2U3boo==true) {
      N2U3angle = atan2(mouseY-N2Y, mouseX-N2X);
      N2U3X = N2X + 40*cos(N2U3angle);
      N2U3Y = N2Y + 40*sin(N2U3angle);
    }     
    //炭素１原子  
    if (C1boo==true) {
      C1X = mouseX;
      C1Y = mouseY;
      C1U1X = C1X + 40*cos(C1U1angle);
      C1U1Y = C1Y + 40*sin(C1U1angle);
      C1U2X = C1X + 40*cos(C1U2angle);
      C1U2Y = C1Y + 40*sin(C1U2angle);
      C1U3X = C1X + 40*cos(C1U3angle);
      C1U3Y = C1Y + 40*sin(C1U3angle);
      C1U4X = C1X + 40*cos(C1U4angle);
      C1U4Y = C1Y + 40*sin(C1U4angle);
    }
    if (C1U1boo==true) {
      C1U1angle = atan2(mouseY-C1Y, mouseX-C1X);
      C1U1X = C1X + 40*cos(C1U1angle);
      C1U1Y = C1Y + 40*sin(C1U1angle);
    }
    if (C1U2boo==true) {
      C1U2angle = atan2(mouseY-C1Y, mouseX-C1X);
      C1U2X = C1X + 40*cos(C1U2angle);
      C1U2Y = C1Y + 40*sin(C1U2angle);
    }
    if (C1U3boo==true) {
      C1U3angle = atan2(mouseY-C1Y, mouseX-C1X);
      C1U3X = C1X + 40*cos(C1U3angle);
      C1U3Y = C1Y + 40*sin(C1U3angle);
    }
    if (C1U4boo==true) {
      C1U4angle = atan2(mouseY-C1Y, mouseX-C1X);
      C1U4X = C1X + 40*cos(C1U4angle);
      C1U4Y = C1Y + 40*sin(C1U4angle);
    }
    //炭素２原子  
    if (C2boo==true) {
      C2X = mouseX;
      C2Y = mouseY;
      C2U1X = C2X + 40*cos(C2U1angle);
      C2U1Y = C2Y + 40*sin(C2U1angle);
      C2U2X = C2X + 40*cos(C2U2angle);
      C2U2Y = C2Y + 40*sin(C2U2angle);
      C2U3X = C2X + 40*cos(C2U3angle);
      C2U3Y = C2Y + 40*sin(C2U3angle);
      C2U4X = C2X + 40*cos(C2U4angle);
      C2U4Y = C2Y + 40*sin(C2U4angle);
    }
    if (C2U1boo==true) {
      C2U1angle = atan2(mouseY-C2Y, mouseX-C2X);
      C2U1X = C2X + 40*cos(C2U1angle);
      C2U1Y = C2Y + 40*sin(C2U1angle);
    }
    if (C2U2boo==true) {
      C2U2angle = atan2(mouseY-C2Y, mouseX-C2X);
      C2U2X = C2X + 40*cos(C2U2angle);
      C2U2Y = C2Y + 40*sin(C2U2angle);
    }
    if (C2U3boo==true) {
      C2U3angle = atan2(mouseY-C2Y, mouseX-C2X);
      C2U3X = C2X + 40*cos(C2U3angle);
      C2U3Y = C2Y + 40*sin(C2U3angle);
    }
    if (C2U4boo==true) {
      C2U4angle = atan2(mouseY-C2Y, mouseX-C2X);
      C2U4X = C2X + 40*cos(C2U4angle);
      C2U4Y = C2Y + 40*sin(C2U4angle);
    }
  }  //マウスが押されている間の処理終了

  //問題文表示
  if (try0 == false) {
    textFont(fontG18); 
    fill(200, 200, 200);   
    text("次の原子を使って分子を作る", 600, 100);
  }
  //各トライごとの表示
  if (try1==true) {
    changeFont();
    fill(255, 150, 150);   
    text("トライ１", 850, 100);  
    fill(255, 255, 255);
    text("水素２原子", 600, 140);
    text("酸素１原子", 600, 170);
    stroke(100, 100, 100);
    strokeWeight(1);
    line(25, 275, 25, 375);  //H2
    line(110, 275, 110, 375);
    line(25, 275, 110, 275);
    line(25, 375, 110, 375);
    line(130, 145, 130, 225);  //O1
    line(230, 145, 230, 225);
    line(130, 145, 230, 145);
    line(130, 225, 230, 225);    
    if (i<60) {  //stop
      i=i+1;
    }
  } else if (try2==true) {
    changeFont();
    fill(255, 150, 150); 
    text("トライ２", 850, 100);  
    fill(255, 255, 255);
    text("窒素２原子", 600, 140);
    stroke(100, 100, 100);
    strokeWeight(1);
    line(240, 61, 240, 225);  //N2
    line(240, 61, 340, 61);
    line(340, 61, 340, 225);
    line(240, 225, 340, 225);        
    if (i<60) {  //stop
      i=i+1;
    }
  } else if (try3==true) {
    changeFont();
    fill(255, 150, 150);   
    text("トライ３", 850, 100);  
    fill(255, 255, 255);
    text("水素３原子", 600, 140);
    text("窒素１原子", 600, 170);
    stroke(100, 100, 100);
    strokeWeight(1);
    line(25, 225, 25, 375);  //H3
    line(110, 225, 110, 375);
    line(25, 225, 110, 225);
    line(25, 375, 110, 375);
    line(240, 143, 240, 225);  //N1
    line(340, 143, 340, 225);
    line(240, 143, 340, 143);
    line(240, 225, 340, 225);    
    if (i<60) {  //stop
      i=i+1;
    }
  } else if (try4==true) {
    changeFont();
    fill(255, 150, 150);   
    text("トライ４", 850, 100);  
    fill(255, 255, 255); 
    text("水素４原子", 600, 140);
    text("炭素１原子", 600, 170);
    stroke(100, 100, 100);
    strokeWeight(1);
    line(25, 175, 25, 375);  //H4
    line(110, 175, 110, 375);
    line(25, 175, 110, 175);
    line(25, 375, 110, 375);
    line(350, 143, 350, 227);  //C1
    line(450, 143, 450, 227);
    line(350, 143, 450, 143);
    line(350, 227, 450, 227);    
    if (i<60) {  //stop
      i=i+1;
    }
  } else if (try5==true) {
    changeFont();
    fill(255, 150, 150);   
    text("トライ５", 850, 100); 
    fill(255, 255, 255);
    text("水素１原子", 600, 140);
    text("窒素１原子", 600, 170);
    text("炭素１原子", 600, 200);
    stroke(100, 100, 100);
    strokeWeight(1);
    line(25, 325, 25, 375);  //H1
    line(110, 325, 110, 375);
    line(25, 325, 110, 325);
    line(25, 375, 110, 375);
    line(350, 143, 350, 227);  //C1
    line(450, 143, 450, 227);
    line(350, 143, 450, 143);
    line(350, 227, 450, 227);    
    line(240, 143, 240, 225);  //N1
    line(340, 143, 340, 225);
    line(240, 143, 340, 143);
    line(240, 225, 340, 225);       

    if (i<60) {  //stop
      i=i+1;
    }
  } else if (try6==true) {
    changeFont();
    fill(255, 150, 150);   
    text("トライ６", 850, 100);  
    fill(255, 255, 255);  
    text("水素４原子", 600, 140);
    text("酸素１原子", 600, 170);    
    text("炭素１原子", 600, 200);
    stroke(100, 100, 100);
    strokeWeight(1);
    line(25, 175, 25, 375);  //H4
    line(110, 175, 110, 375);
    line(25, 175, 110, 175);
    line(25, 375, 110, 375);
    line(130, 145, 130, 225);  //O1
    line(230, 145, 230, 225);
    line(130, 145, 230, 145);
    line(130, 225, 230, 225);    
    line(350, 143, 350, 227);  //C1
    line(450, 143, 450, 227);
    line(350, 143, 450, 143);
    line(350, 227, 450, 227);      

    if (i<60) {  //stop
      i=i+1;
    }
  } else if (try7==true) {
    changeFont();
    fill(255, 150, 150);   
    text("トライ７", 850, 100);  
    fill(255, 255, 255); 
    text("水素６原子", 600, 140);
    text("酸素１原子", 600, 170);    
    text("炭素２原子", 600, 200);
    stroke(100, 100, 100);
    strokeWeight(1);
    line(25, 75, 25, 375);  //H6
    line(110, 75, 110, 375);
    line(25, 75, 110, 75);
    line(25, 375, 110, 375); 
    line(130, 145, 130, 225);  //O1
    line(230, 145, 230, 225);
    line(130, 145, 230, 145);
    line(130, 225, 230, 225); 
    line(350, 58, 350, 227);  //C2
    line(450, 58, 450, 227);
    line(350, 58, 450, 58);
    line(350, 227, 450, 227);          

    if (i<60) {  //stop
      i=i+1;
    }
    fill(255, 150, 150); 
    textFont(fontG18);   
    text("２種類の分子ができます", 600, 240);
    fill(255, 255, 255);
    text("画像表示は <A>キー、<Z>キー", 630, 270);
  } else if (try8==true) {
    changeFont();
    fill(255, 150, 150);   
    text("トライ８", 850, 100);  
    fill(255, 255, 255);  
    text("水素６原子", 600, 140);
    text("炭素２原子", 600, 170);
    stroke(100, 100, 100);
    strokeWeight(1);
    line(25, 75, 25, 375);  //H6
    line(110, 75, 110, 375);
    line(25, 75, 110, 75);
    line(25, 375, 110, 375);     
    line(350, 58, 350, 227);  //C2
    line(450, 58, 450, 227);
    line(350, 58, 450, 58);
    line(350, 227, 450, 227);             
    if (i<60) {  //stop
      i=i+1;
    }
  } else if (try9==true) {
    changeFont();
    fill(255, 150, 150);   
    text("トライ９", 850, 100);  
    fill(255, 255, 255);  
    text("水素４原子", 600, 140);
    text("炭素２原子", 600, 170);
    stroke(100, 100, 100);
    strokeWeight(1);
    line(25, 175, 25, 375);  //H4
    line(110, 175, 110, 375);
    line(25, 175, 110, 175);
    line(25, 375, 110, 375);    
    line(350, 58, 350, 227);  //C2
    line(450, 58, 450, 227);
    line(350, 58, 450, 58);
    line(350, 227, 450, 227);          
    if (i<60) {  //stop
      i=i+1;
    }
  } else if (try10==true) {
    changeFont();
    fill(255, 150, 150);   
    text("トライ１0", 850, 100);  
    fill(255, 255, 255); 
    text("水素２原子", 600, 140);
    text("炭素２原子", 600, 170);
    stroke(100, 100, 100);
    strokeWeight(1);
    line(25, 275, 25, 375);  //H2
    line(110, 275, 110, 375);
    line(25, 275, 110, 275);
    line(25, 375, 110, 375);
    line(350, 58, 350, 227);  //C2
    line(450, 58, 450, 227);
    line(350, 58, 450, 58);
    line(350, 227, 450, 227);         

    if (i<60) {  //stop
      i=i+1;
    }
  } else if (try11==true) {
    changeFont();
    fill(255, 150, 150);   
    text("トライ１１", 850, 100);  
    fill(255, 255, 255);
    text("水素４原子", 600, 140);
    text("酸素２原子", 600, 170);    
    text("炭素２原子", 600, 200);
    stroke(100, 100, 100);
    strokeWeight(1);
    line(25, 175, 25, 375);  //H4
    line(110, 175, 110, 375);
    line(25, 175, 110, 175);
    line(25, 375, 110, 375);    
    line(130, 61, 130, 225);  //O2
    line(230, 61, 230, 225);
    line(130, 61, 230, 61);
    line(130, 225, 230, 225);     
    line(350, 58, 350, 227);  //C2
    line(450, 58, 450, 227);
    line(350, 58, 450, 58);
    line(350, 227, 450, 227);             

    if (i<60) {  //stop
      i=i+1;
    }
  } else if (try12==true) {
    changeFont();
    fill(255, 150, 150);   
    text("トライ１２", 850, 100);  
    fill(255, 255, 255); 
    text("水素４原子", 600, 140);
    text("酸素１原子", 600, 170);    
    text("炭素２原子", 600, 200);
    stroke(100, 100, 100);
    strokeWeight(1);
    line(25, 175, 25, 375);  //H4
    line(110, 175, 110, 375);
    line(25, 175, 110, 175);
    line(25, 375, 110, 375);    
    line(130, 145, 130, 225);  //O1
    line(230, 145, 230, 225);
    line(130, 145, 230, 145);
    line(130, 225, 230, 225);    
    line(350, 58, 350, 227);  //C2
    line(450, 58, 450, 227);
    line(350, 58, 450, 58);
    line(350, 227, 450, 227);      
    if (i<60) {  //stop
      i=i+1;
    }
  }

  //各原子の描画
  //水素原子１描画
  fill(255, 255, 255);
  noStroke();
  ellipse(H1X, H1Y, 45, 45);
  stroke(255, 255, 255);
  strokeWeight(5);
  line(H1X, H1Y, H1U1X, H1U1Y);  
  if (try1==true || try3==true || try4==true || try5==true || try6==true || try7==true || try8==true || 
    try9==true || try10==true || try11==true || try12==true) { 
    fill(200, 0, 0);
    textSize(25);
    text("Ｈ", H1X-12, H1Y+9);
  } else {
    fill(0, 0, 0);
    textSize(20);
    text("Ｈ", H1X-10, H1Y+7);
  }
  //水素原子２描画
  fill(255, 255, 255);
  noStroke();
  ellipse(H2X, H2Y, 45, 45);
  stroke(255, 255, 255);
  strokeWeight(5);
  line(H2X, H2Y, H2U1X, H2U1Y); 
  if (try1==true || try3==true || try4==true || try6==true || try7==true || try8==true || try9==true || 
    try10==true || try11==true || try12==true) { 
    fill(200, 0, 0);
    textSize(25);
    text("Ｈ", H2X-12, H2Y+9);
  } else {
    fill(0, 0, 0);
    textSize(20);
    text("Ｈ", H2X-10, H2Y+7);
  }

  //水素原子３描画
  fill(255, 255, 255);
  noStroke();
  ellipse(H3X, H3Y, 45, 45);
  stroke(255, 255, 255);
  strokeWeight(5);
  line(H3X, H3Y, H3U1X, H3U1Y);  
  if (try3==true || try4==true || try6==true || try7==true || try8==true || try9==true || 
    try11==true || try12==true) { 
    fill(200, 0, 0);
    textSize(25);
    text("Ｈ", H3X-12, H3Y+9);
  } else {
    fill(0, 0, 0);
    textSize(20);
    text("Ｈ", H3X-10, H3Y+7);
  }
  //水素原子４描画
  fill(255, 255, 255);
  noStroke();
  ellipse(H4X, H4Y, 45, 45);
  stroke(255, 255, 255);
  strokeWeight(5);
  line(H4X, H4Y, H4U1X, H4U1Y);  
  if (try4==true || try6==true || try7==true || try8==true || try9==true || 
    try11==true || try12==true) { 
    fill(200, 0, 0);
    textSize(25);
    text("Ｈ", H4X-12, H4Y+9);
  } else {
    fill(0, 0, 0);
    textSize(20);
    text("Ｈ", H4X-10, H4Y+7);
  }
  //水素原子５描画
  fill(255, 255, 255);
  noStroke();
  ellipse(H5X, H5Y, 45, 45);
  stroke(255, 255, 255);
  strokeWeight(5);
  line(H5X, H5Y, H5U1X, H5U1Y);  
  if (try7==true || try8==true ) {
    fill(200, 0, 0);
    textSize(25);
    text("Ｈ", H5X-12, H5Y+9);
  } else {
    fill(0, 0, 0);
    textSize(20);
    text("Ｈ", H5X-10, H5Y+7);
  }
  //水素原子６描画
  fill(255, 255, 255);
  noStroke();
  ellipse(H6X, H6Y, 45, 45);
  stroke(255, 255, 255);
  strokeWeight(5);
  line(H6X, H6Y, H6U1X, H6U1Y);  
  if (try7==true || try8==true ) { 
    fill(200, 0, 0);
    textSize(25);
    text("Ｈ", H6X-12, H6Y+9);
  } else {
    fill(0, 0, 0);
    textSize(20);
    text("Ｈ", H6X-10, H6Y+7);
  }
  //酸素原子１描画
  fill(255, 0, 0);
  noStroke();
  ellipse(O1X, O1Y, 60, 60);
  stroke(255, 0, 0);
  strokeWeight(5);
  line(O1X, O1Y, O1U1X, O1U1Y);  
  line(O1X, O1Y, O1U2X, O1U2Y); 
  if (try1==true || try6==true || try7==true || try11==true || try12==true) {
    fill(0, 255, 0);
    textSize(28);
    text("Ｏ", O1X-13, O1Y+10);
  } else {
    fill(255, 255, 255);
    textSize(20);
    text("Ｏ", O1X-10, O1Y+7);
  }
  //酸素原子２描画
  fill(255, 0, 0);
  noStroke();
  ellipse(O2X, O2Y, 60, 60);
  stroke(255, 0, 0);
  strokeWeight(5);
  line(O2X, O2Y, O2U1X, O2U1Y);  
  line(O2X, O2Y, O2U2X, O2U2Y);  
  if (try11==true ) {
    fill(0, 255, 0);
    textSize(28);
    text("Ｏ", O2X-13, O2Y+10);
  } else {
    fill(255, 255, 255);
    textSize(20);
    text("Ｏ", O2X-10, O2Y+7);
  }
  //窒素原子１描画 
  fill(0, 0, 255);
  noStroke();
  ellipse(N1X, N1Y, 60, 60); 
  stroke(0, 0, 255);
  strokeWeight(5);
  line(N1X, N1Y, N1U1X, N1U1Y);  
  line(N1X, N1Y, N1U2X, N1U2Y); 
  line(N1X, N1Y, N1U3X, N1U3Y);  
  if (try2==true || try3==true || try5==true) {
    fill(255, 220, 12);
    textSize(28);
    text("Ｎ", N1X-13, N1Y+10);
  } else {
    fill(255, 255, 255);
    textSize(20);
    text("Ｎ", N1X-10, N1Y+7);
  }

  //窒素原子２描画 
  fill(0, 0, 255);
  noStroke();
  ellipse(N2X, N2Y, 60, 60); 
  stroke(0, 0, 255);
  strokeWeight(5);
  line(N2X, N2Y, N2U1X, N2U1Y);  
  line(N2X, N2Y, N2U2X, N2U2Y); 
  line(N2X, N2Y, N2U3X, N2U3Y);  
  if (try2==true) {
    fill(255, 220, 0);
    textSize(28);
    text("Ｎ", N2X-13, N2Y+10);
  } else {
    fill(255, 255, 255);
    textSize(20);
    text("Ｎ", N2X-10, N2Y+7);
  }
  //炭素原子１描画 
  fill(120, 120, 120);
  noStroke();
  ellipse(C1X, C1Y, 60, 60); 
  stroke(120, 120, 120);
  strokeWeight(5);
  line(C1X, C1Y, C1U1X, C1U1Y);  
  line(C1X, C1Y, C1U2X, C1U2Y); 
  line(C1X, C1Y, C1U3X, C1U3Y);  
  line(C1X, C1Y, C1U4X, C1U4Y); 
  if (try4==true || try5==true || try6==true || try7==true || try8==true || try9==true ||
    try10==true || try11==true || try12==true) {
    fill(255, 255, 0);
    textSize(28);
    text("Ｃ", C1X-13, C1Y+10);
  } else {
    fill(255, 255, 255);
    textSize(20);
    text("Ｃ", C1X-10, C1Y+7);
  }
  //炭素原子２描画 
  fill(120, 120, 120);
  noStroke();
  ellipse(C2X, C2Y, 60, 60); 
  stroke(120, 120, 120);
  strokeWeight(5);
  line(C2X, C2Y, C2U1X, C2U1Y);  
  line(C2X, C2Y, C2U2X, C2U2Y); 
  line(C2X, C2Y, C2U3X, C2U3Y);  
  line(C2X, C2Y, C2U4X, C2U4Y); 
  if (try7==true || try8==true || try9==true ||try10==true || try11==true || try12==true) {
    fill(255, 255, 0);
    textSize(28);
    text("Ｃ", C2X-13, C2Y+10);
  } else {
    fill(255, 255, 255);
    textSize(20);
    text("Ｃ", C2X-10, C2Y+7);
  }

  //各tryの結合描写
  //try0
  if (try0==true) {
    bond_clear();
    HObond();
    HNbond();
    HCbond();
    OCbond();
    NCbond();
    CCbond();
    NNbond();
    OObond();
  } 

  //try1 
  if (try1==true) {
    bond_clear();
    HObond();
    if (O1U1bond==true && O1U2bond==true) {
      textFont(fontG35);
      fill(255, 255, 0);
      text("水分子完成！", 615, 320);
      fill(255, 255, 255);  
      textFont(fontG25); 
      text("生命を維持するのに不可欠な液体", 615, 400);      
      text("極性分子で、様々な物質を溶かす", 615, 450);      
      text("成人の人体の60パーセントが水", 615, 500);
      try1OK=true;
      if (mousePressed==false) {
        fill(255, 0, 0); 
        text("水素原子が移動します", 615, 550);
      }

      if (j<240  && mousePressed==false) {
        j=j+1;
      }
      int k=j-60;
      if (k>0) {
        if (H1X>=H2X) {
          H1X = O1X + 70*cos(conAng * k);//H1
          H1Y = O1Y + 70*sin(conAng * k);
          H1U1X = H1X - 30*cos(conAng * k);
          H1U1Y = H1Y - 30*sin(conAng * k);
          O1U1X = O1X + 40*cos(conAng * k);
          O1U1Y = O1Y + 40*sin(conAng * k);

          H2X = O1X - 70*cos(conAng * k);//H2
          H2Y = O1Y + 70*sin(conAng * k);
          H2U1X = H2X + 30*cos(conAng * k);
          H2U1Y = H2Y - 30*sin(conAng * k);
          O1U2X = O1X - 40*cos(conAng * k);
          O1U2Y = O1Y + 40*sin(conAng * k);
        } else if (H1X<H2X) {
          H2X = O1X + 70*cos(conAng * k);//H1
          H2Y = O1Y + 70*sin(conAng * k);
          H2U1X = H2X - 30*cos(conAng * k);
          H2U1Y = H2Y - 30*sin(conAng * k);
          O1U1X = O1X + 40*cos(conAng * k);
          O1U1Y = O1Y + 40*sin(conAng * k);

          H1X = O1X - 70*cos(conAng * k);//H2
          H1Y = O1Y + 70*sin(conAng * k);
          H1U1X = H1X + 30*cos(conAng * k);
          H1U1Y = H1Y - 30*sin(conAng * k);
          O1U2X = O1X - 40*cos(conAng * k);
          O1U2Y = O1Y + 40*sin(conAng * k);
        }
      }
      if (j==240) {
        fill(255, 255, 255); 
        textSize(20);
        text("これが水分子の構造（折れ線型）です", 615, 580);  
        text("二酸化炭素分子の構造は直線型です", 615, 610);   
        text("この違いはどこから来るか調べてみよう", 615, 640);
        textSize(25);
        fill(255, 255, 0);
        text("<A>キーを押すと画像を表示する", 615, 685);
      }
    }
  }  
  //try2 
  if (try2==true) {
    bond_clear();
    NNbond();
    if (N1U1bond==true && N1U2bond==true && N1U3bond==true && N2U1bond==true && N2U2bond==true  && N2U3bond==true) {
      textFont(fontG35); 
      fill(255, 255, 0);
      text("窒素分子完成！", 615, 320);
      fill(255, 255, 255);  
      textFont(fontG25); 
      text("常温常圧では無色無臭の気体", 615, 400);      
      text("空気の７８％が窒素", 615, 450);      
      text("冷却剤の液体窒素は－196℃", 615, 500);
      fill(255, 255, 0);
      text("<A>キーを押すと画像を表示する", 615, 600); 
      try2OK=true;
    }
  }  
  //try3
  if (try3==true) {
    bond_clear();
    HNbond();
    if (N1U1bond==true && N1U2bond==true  && N1U3bond==true ) {
      textFont(fontG35); 
      fill(255, 255, 0);  
      text("アンモニア分子完成！", 615, 320);
      fill(255, 255, 255);  
      textFont(fontG25); 
      text("無色の刺激臭のある有毒気体", 615, 400);      
      text("水によく溶ける（アンモニア水）", 615, 450);      
      text("窒素肥料の原料物質", 615, 500);
      fill(255, 255, 0);
      text("<A>キーを押すと画像を表示する", 615, 600); 
      try3OK=true;
    }
  }  
  //try4
  if (try4==true) {
    bond_clear();
    HCbond(); 
    if (C1U1bond==true && C1U2bond==true  && C1U3bond==true  && C1U4bond==true) {
      textFont(fontG35); 
      fill(255, 255, 0);
      text("メタン分子完成！", 615, 320);
      fill(255, 255, 255);  
      textFont(fontG25); 
      text("無色無臭の気体。毒性なし", 615, 400);      
      text("和名は沼気(メタン菌の嫌気発酵)", 615, 450);      
      text("燃焼すると水と二酸化炭素になる", 615, 500);
      fill(255, 255, 0);
      text("<A>キーを押すと画像を表示する", 615, 600); 
      try4OK=true;
    }
  }   
  //try5
  if (try5==true) {
    bond_clear();
    HCbond(); 
    HNbond();
    NCbond();
    if (C1U1bond==true && C1U2bond==true  && C1U3bond==true  && C1U4bond==true) {
      textFont(fontG35); 
      fill(255, 255, 0);    
      text("シアン化水素分子完成！", 615, 320);
      fill(255, 255, 255);  
      textFont(fontG25); 
      text("猛毒", 615, 400);      
      text("ＨがＫになると青酸カリ", 615, 450);      
      text("未熟な梅に含まれる毒性成分", 615, 500);
      fill(255, 255, 0);
      text("<A>キーを押すと画像を表示する", 615, 600); 
      try5OK=true;
    }
  }

  //try6
  if (try6==true) {
    bond_clear();
    HCbond(); 
    HObond();
    OCbond();
    if (H1U1bond==true && H2U1bond==true && H3U1bond==true && H4U1bond==true && C1U1bond==true && 
      C1U2bond==true  && C1U3bond==true  && C1U4bond==true && O1U1bond==true && O1U2bond==true ) {
      textFont(fontG35); 
      fill(255, 255, 0);
      text("メタノール分子完成！", 615, 320);
      fill(255, 255, 255);  
      textFont(fontG25); 
      text("アルコールの中で一番小さな分子", 615, 400);      
      text("引火しやすい", 615, 450);      
      text("飲むと中毒症状(失明等)を起こす", 615, 500);
      fill(255, 255, 0);
      text("<A>キーを押すと画像を表示する", 615, 600);       
      try6OK=true;
    }
  } 

  //try7
  if (try7==true) {
    bond_clear();
    HOlink=false;
    HCbond(); 
    HObond();
    OCbond();
    CCbond();
    if (H1U1bond==true && H2U1bond==true && H3U1bond==true && H4U1bond==true && H5U1bond==true && 
      H6U1bond==true && C1U1bond==true && C1U2bond==true  && C1U3bond==true  && C1U4bond==true && 
      C2U1bond==true && C2U2bond==true  && C2U3bond==true  && C2U4bond==true&& O1U1bond==true && O1U2bond==true ) {
      if (HOlink==true) {
        textFont(fontG35);
        fill(255, 255, 0);
        text("エタノール分子完成！", 615, 320);
        textFont(fontG18);
        fill(255, 255, 255);  
        textFont(fontG25); 
        text("殺菌、消毒、燃料等に利用", 615, 400);      
        text("酒の中に入っている", 615, 450);      
        text("車の燃料としての利用がある", 615, 500);
        fill(255, 255, 0);
        text("<A>キーを押すと画像を表示する", 615, 600);
      } else if (HOlink==false) {
        textFont(fontG35); 
        fill(255, 255, 0);
        text("ジメチルエーテル", 615, 320);
        text("分子完成！", 615, 360);
        textFont(fontG18);
        fill(255, 255, 255);  
        textFont(fontG25); 
        text("麻酔性がある気体", 615, 440);      
        text("スプレー缶に使われている", 615, 490);      
        text("燃料として使われている", 615, 540);
        fill(255, 255, 0);
        text("<Z>キーを押すと画像を表示する", 615, 640);
      }
      try7OK=true;
    }
  }
  //try8
  if (try8==true) {
    bond_clear();
    HCbond(); 
    CCbond();
    if (C1U1bond==true && C1U2bond==true  && C1U3bond==true  && C1U4bond==true &&  C2U1bond==true && 
      C2U2bond==true  && C2U3bond==true  && C2U4bond==true) {
      textFont(fontG35);
      fill(255, 255, 0);
      text("エタン分子完成！", 615, 320);
      fill(255, 255, 255);  
      textFont(fontG25); 
      text("可燃性の気体", 615, 400);      
      text("天然ガス中に含まれている", 615, 450);      
      text("様々な化学物質の原料になる", 615, 500);
      fill(255, 255, 0);
      text("<A>キーを押すと画像を表示する", 615, 600);    
      try8OK=true;
    }
  } 

  //try9
  if (try9==true) {
    bond_clear();
    HCbond(); 
    CCbond();
    if (C1U1bond==true && C1U2bond==true  && C1U3bond==true  && C1U4bond==true &&  C2U1bond==true && 
      C2U2bond==true  && C2U3bond==true  && C2U4bond==true) {
      textFont(fontG35); 
      fill(255, 255, 0);
      text("エチレン分子完成！", 615, 320);
      fill(255, 255, 255);  
      textFont(fontG25); 
      text("無色の引火しやすい気体", 615, 400);      
      text("ポリエチレンの原料", 615, 450);      
      text("植物が作る植物ホルモン", 615, 500);
      fill(255, 255, 0);
      text("<A>キーを押すと画像を表示する", 615, 600);    
      try9OK=true;
    }
  }  

  //try10
  if (try10==true) {
    bond_clear();
    HCbond(); 
    CCbond();
    if (C1U1bond==true && C1U2bond==true  && C1U3bond==true  && C1U4bond==true &&  C2U1bond==true && 
      C2U2bond==true  && C2U3bond==true  && C2U4bond==true) {
      textFont(fontG35); 
      fill(255, 255, 0);
      text("アセチレン分子完成！", 615, 320);
      fill(255, 255, 255);  
      textFont(fontG25); 
      text("ガス溶接の燃焼ガスに利用", 615, 400);      
      text("純粋なものは無色無臭の気体", 615, 450);      
      text("様々な化学物質の原料になる", 615, 500);
      fill(255, 255, 0);
      text("<A>キーを押すと画像を表示する", 615, 600);    
      try10OK=true;
    }
  } 

  //try11
  if (try11==true) {
    bond_clear();
    HCbond(); 
    HObond();
    OCbond();
    CCbond();
    OObond();
    if (H1U1bond==true && H2U1bond==true && H3U1bond==true && H4U1bond==true && C1U1bond==true && 
      C1U2bond==true  && C1U3bond==true  && C1U4bond==true && C2U1bond==true && C2U2bond==true && 
      C2U3bond==true  && C2U4bond==true && O1U1bond==true && O1U2bond==true && O2U1bond==true && O2U2bond==true) {
      textFont(fontG35); 
      fill(255, 255, 0);
      text("分子完成！", 615, 320);
      textFont(fontG25); 
      text("たくさんの種類の分子がある", 615, 400);
      text("<A>キーでそれらを表示", 615, 450);
      text("<Z>キーで酢酸を表示", 615, 500);
      try11OK=true;
    }
  } 

  //try12
  if (try12==true) {
    bond_clear();
    HCbond(); 
    HObond();
    OCbond();
    CCbond();
    if (H1U1bond==true && H2U1bond==true && H3U1bond==true && H4U1bond==true && C1U1bond==true && 
      C1U2bond==true  && C1U3bond==true  && C1U4bond==true && C2U1bond==true && C2U2bond==true && 
      C2U3bond==true  && C2U4bond==true && O1U1bond==true && O1U2bond==true ) {
      textFont(fontG35); 
      fill(255, 255, 0);
      text("分子完成！", 615, 320);
      textFont(fontG25); 
      text("３種類の分子がある", 615, 400);
      text("<A>キー;３種類表示", 615, 450);
      text("<Z>キー；アセトアルデヒド表示", 615, 500);
      try12OK=true;
    }
  }  //end of try

  //説明画像表示（void draw()の中)
  if (IMGboo == true) {
    if (try0==true) {
      image(IMG0, 600, 50, 400, 680 );
    } else if (try1==true) {
      image(IMG1, 600, 50, 400, 680 );
    } else if (try2==true) {
      image(IMG2, 600, 50, 400, 680 );
    } else if (try3==true) {
      image(IMG3, 600, 50, 400, 680 );
    } else if (try4==true) {
      image(IMG4, 600, 50, 400, 680 );
    } else if (try5==true) {
      image(IMG5, 600, 50, 400, 680 );
    } else if (try6==true) {
      image(IMG6, 600, 50, 400, 680 );
    } else if (try7==true) {
      if (try7img==true) {
        image(IMG7_1, 600, 50, 400, 680 );
      } else if (try7img==false) {
        image(IMG7_2, 600, 50, 400, 680 );
      }
    } else if (try8==true) {
      image(IMG8, 600, 50, 400, 680 );
    } else if (try9==true) {
      image(IMG9, 600, 50, 400, 680 );
    } else if (try10==true) {
      image(IMG10, 600, 50, 400, 680 );
    } else if (try11==true) {
      if (try11img==true) {
        image(IMG11_1, 600, 50, 400, 680 );
      } else if (try11img==false) {
        image(IMG11_2, 600, 50, 400, 680 );
      }
    } else if (try12==true) {
      if (try12img==true) {
        image(IMG12_1, 600, 50, 400, 680 );
      } else if (try12img==false) {
        image(IMG12_2, 600, 50, 400, 680 );
      }
    }
  }  //説明画像表示終了

  hand();  //ポインターの形を状況に応じて変える関数

  if (try1OK==true && try2OK==true && try3OK==true && try4OK==true && 
    try5OK==true && try6OK==true && try7OK==true && try8OK==true && 
    try9OK==true && try10OK==true && try11OK==true && try12OK==true ) {
    textFont(fontG45);
    fill(255, 0, 0);
    text("おめでとう　全問正解！", 70, 700);
  }
}  //end of void draw 

void mousePressed() {
  //全ての腕のブーレアンをfalseにする
  H1boo=false;
  H1U1boo=false;
  H2boo=false;
  H2U1boo=false;
  H3boo=false;
  H3U1boo=false;
  H4boo=false;
  H4U1boo=false;
  H5boo=false;
  H5U1boo=false;
  H6boo=false;
  H6U1boo=false;
  O1boo=false;
  O1U1boo=false;
  O1U2boo=false;
  O2boo=false;
  O2U1boo=false;
  O2U2boo=false;
  N1boo=false;
  N1U1boo=false;
  N1U2boo=false;
  N1U3boo=false;
  N2boo=false;
  N2U1boo=false;
  N2U2boo=false;
  N2U3boo=false;
  C1boo=false;
  C1U1boo=false;
  C1U2boo=false;
  C1U3boo=false;
  C1U4boo=false;
  C2boo=false;
  C2U1boo=false;
  C2U2boo=false;
  C2U3boo=false;
  C2U4boo=false;

  //それぞれの近傍でマウスがクリックされたらブーレアンをtrueにする
  if (mouseX>H1X-15 && mouseX<H1X+15 && mouseY>H1Y-15 && mouseY<H1Y+15) {
    H1boo=true;
  } else if (mouseX>H1U1X-15 && mouseX<H1U1X+15 && mouseY>H1U1Y-15 && mouseY<H1U1Y+15) {
    H1U1boo=true;
  } else if (mouseX>H2X-15 && mouseX<H2X+15 && mouseY>H2Y-15 && mouseY<H2Y+15) {
    H2boo=true;
  } else if (mouseX>H2U1X-15 && mouseX<H2U1X+15 && mouseY>H2U1Y-15 && mouseY<H2U1Y+15) {
    H2U1boo=true;
  } else if (mouseX>H3X-15 && mouseX<H3X+15 && mouseY>H3Y-15 && mouseY<H3Y+15) {
    H3boo=true;
  } else if (mouseX>H3U1X-15 && mouseX<H3U1X+15 && mouseY>H3U1Y-15 && mouseY<H3U1Y+15) {
    H3U1boo=true;
  } else if (mouseX>H4X-15 && mouseX<H4X+15 && mouseY>H4Y-15 && mouseY<H4Y+15) {
    H4boo=true;
  } else if (mouseX>H4U1X-15 && mouseX<H4U1X+15 && mouseY>H4U1Y-15 && mouseY<H4U1Y+15) {
    H4U1boo=true;
  } else if (mouseX>H5X-15 && mouseX<H5X+15 && mouseY>H5Y-15 && mouseY<H5Y+15) {
    H5boo=true;
  } else if (mouseX>H5U1X-15 && mouseX<H5U1X+15 && mouseY>H5U1Y-15 && mouseY<H5U1Y+15) {
    H5U1boo=true;
  } else if (mouseX>H6X-15 && mouseX<H6X+15 && mouseY>H6Y-15 && mouseY<H6Y+15) {
    H6boo=true;
  } else if (mouseX>H6U1X-15 && mouseX<H6U1X+15 && mouseY>H6U1Y-15 && mouseY<H6U1Y+15) {
    H6U1boo=true;
  } else if (mouseX>O1X-15 && mouseX<O1X+15 && mouseY>O1Y-15 && mouseY<O1Y+15) {
    O1boo=true;
  } else if (mouseX>O1U1X-15 && mouseX<O1U1X+15 && mouseY>O1U1Y-15 && mouseY<O1U1Y+15) {
    O1U1boo=true;
  } else if (mouseX>O1U2X-15 && mouseX<O1U2X+15 && mouseY>O1U2Y-15 && mouseY<O1U2Y+15) {
    O1U2boo=true;
  } else if (mouseX>O2X-15 && mouseX<O2X+15 && mouseY>O2Y-15 && mouseY<O2Y+15) {
    O2boo=true;
  } else if (mouseX>O2U1X-15 && mouseX<O2U1X+15 && mouseY>O2U1Y-15 && mouseY<O2U1Y+15) {
    O2U1boo=true;
  } else if (mouseX>O2U2X-15 && mouseX<O2U2X+15 && mouseY>O2U2Y-15 && mouseY<O2U2Y+15) {
    O2U2boo=true;
  } else if (mouseX>N1X-15 && mouseX<N1X+15 && mouseY>N1Y-15 && mouseY<N1Y+15) {
    N1boo=true;
  } else if (mouseX>N1U1X-15 && mouseX<N1U1X+15 && mouseY>N1U1Y-15 && mouseY<N1U1Y+15) {
    N1U1boo=true;
  } else if (mouseX>N1U2X-15 && mouseX<N1U2X+15 && mouseY>N1U2Y-15 && mouseY<N1U2Y+15) {
    N1U2boo=true;
  } else if (mouseX>N1U3X-15 && mouseX<N1U3X+15 && mouseY>N1U3Y-15 && mouseY<N1U3Y+15) {
    N1U3boo=true;
  } else if (mouseX>N2X-15 && mouseX<N2X+15 && mouseY>N2Y-15 && mouseY<N2Y+15) {
    N2boo=true;
  } else if (mouseX>N2U1X-15 && mouseX<N2U1X+15 && mouseY>N2U1Y-15 && mouseY<N2U1Y+15) {
    N2U1boo=true;
  } else if (mouseX>N2U2X-15 && mouseX<N2U2X+15 && mouseY>N2U2Y-15 && mouseY<N2U2Y+15) {
    N2U2boo=true;
  } else if (mouseX>N2U3X-15 && mouseX<N2U3X+15 && mouseY>N2U3Y-15 && mouseY<N2U3Y+15) {
    N2U3boo=true;
  } else if (mouseX>C1X-15 && mouseX<C1X+15 && mouseY>C1Y-15 && mouseY<C1Y+15) {
    C1boo=true;
  } else if (mouseX>C1U1X-15 && mouseX<C1U1X+15 && mouseY>C1U1Y-15 && mouseY<C1U1Y+15) {
    C1U1boo=true;
  } else if (mouseX>C1U2X-15 && mouseX<C1U2X+15 && mouseY>C1U2Y-15 && mouseY<C1U2Y+15) {
    C1U2boo=true;
  } else if (mouseX>C1U3X-15 && mouseX<C1U3X+15 && mouseY>C1U3Y-15 && mouseY<C1U3Y+15) {
    C1U3boo=true;
  } else if (mouseX>C1U4X-15 && mouseX<C1U4X+15 && mouseY>C1U4Y-15 && mouseY<C1U4Y+15) {
    C1U4boo=true;
  } else if (mouseX>C2X-15 && mouseX<C2X+15 && mouseY>C2Y-15 && mouseY<C2Y+15) {
    C2boo=true;
  } else if (mouseX>C2U1X-15 && mouseX<C2U1X+15 && mouseY>C2U1Y-15 && mouseY<C2U1Y+15) {
    C2U1boo=true;
  } else if (mouseX>C2U2X-15 && mouseX<C2U2X+15 && mouseY>C2U2Y-15 && mouseY<C2U2Y+15) {
    C2U2boo=true;
  } else if (mouseX>C2U3X-15 && mouseX<C2U3X+15 && mouseY>C2U3Y-15 && mouseY<C2U3Y+15) {
    C2U3boo=true;
  } else if (mouseX>C2U4X-15 && mouseX<C2U4X+15 && mouseY>C2U4Y-15 && mouseY<C2U4Y+15) {
    C2U4boo=true;
  }
  // ボタン近傍でクリックしたらそのボタンを選択  
  if (mouseX>510-5 && mouseX<510+5 && mouseY>298-17*0-5 && mouseY<298-17*0+5) {
    shokiti();
    try0=true;
  } else if (mouseX>510-5 && mouseX<510+5 && mouseY>298-17*1-5 && mouseY<298-17*1+5) {
    shokiti();
    try1=true;
    j=0;
  } else if (mouseX>510-5 && mouseX<510+5 && mouseY>298-17*2-5 && mouseY<298-17*2+5) {
    shokiti();
    try2=true;
  } else if (mouseX>510-5 && mouseX<510+5 && mouseY>298-17*3-5 && mouseY<298-17*3+5) {
    shokiti();
    try3=true;
  } else if (mouseX>510-5 && mouseX<510+5 && mouseY>298-17*4-5 && mouseY<298-17*4+5) {
    shokiti();
    try4=true;
  } else if (mouseX>510-5 && mouseX<510+5 && mouseY>298-17*5-5 && mouseY<298-17*5+5) {
    shokiti();
    try5=true;
  } else if (mouseX>510-5 && mouseX<510+5 && mouseY>298-17*6-5 && mouseY<298-17*6+5) {
    shokiti();
    try6=true;
  } else if (mouseX>510-5 && mouseX<510+5 && mouseY>298-17*7-5 && mouseY<298-17*7+5) {
    shokiti();
    try7=true;
  } else if (mouseX>510-5 && mouseX<510+5 && mouseY>298-17*8-5 && mouseY<298-17*8+5) {
    shokiti();
    try8=true;
  } else if (mouseX>510-5 && mouseX<510+5 && mouseY>298-17*9-5 && mouseY<298-17*9+5) {
    shokiti();
    try9=true;
  } else if (mouseX>510-5 && mouseX<510+5 && mouseY>298-17*10-5 && mouseY<298-17*10+5) {
    shokiti();
    try10=true;
  } else if (mouseX>510-5 && mouseX<510+5 && mouseY>298-17*11-5 && mouseY<298-17*11+5) {
    shokiti();
    try11=true;
  } else if (mouseX>510-5 && mouseX<510+5 && mouseY>298-17*12-5 && mouseY<298-17*12+5) {
    shokiti();
    try12=true;
  }

  //<A>,<Z>ボタン選択時  
  if (mouseX>25 && mouseX<60 && mouseY>640 && mouseY<675) { 
    if (IMGboo == true) {
      IMGboo = false;
    } else if (IMGboo == false) {
      IMGboo = true;
      try7img=true;
      try11img=true;
      try12img=true;
    }
  } else if (mouseX>25 && mouseX<60 && mouseY>680 && mouseY<715) {
    if (try7==true) {
      if (IMGboo == true) {
        IMGboo = false;
      } else if (IMGboo == false) {
        IMGboo = true;
        try7img=false;
      }
    }

    if (try11==true) {
      if (IMGboo == true) {
        IMGboo = false;
      } else if (IMGboo == false) {
        IMGboo = true;
        try11img=false;
      }
    }
    if (try12==true) {
      if (IMGboo == true) {
        IMGboo = false;
      } else if (IMGboo == false) {
        IMGboo = true;
        try12img=false;
      }
    }
  }
}  //end of  mousePresse


void keyPressed() { 
  if (key == '1') { 
    shokiti();
    j=0;
    try1 = true;
  } else if (key == '2') { 
    shokiti();
    try2 = true;
  } else if (key == '3') { 
    shokiti();
    try3 = true;
  } else if (key == '4') { 
    shokiti();
    try4 = true;
  } else if (key == '5') { 
    shokiti();
    try5 = true;
  } else if (key == '6') { 
    shokiti();
    try6 = true;
  } else if (key == '7') { 
    shokiti();
    try7 = true;
  } else if (key == '8') { 
    shokiti();
    try8 = true;
  } else if (key == '9') { 
    shokiti();
    try9 = true;
  } else if (key == '0') { 
    shokiti();
    try10 = true;
  } else if (key == 'Q'|| key == 'q' ) { 
    shokiti();
    try11 = true;
  } else if (key == 'W' || key == 'w') { 
    shokiti();
    try12 = true;
  } else if (key == 'S' || key == 's') { 
    shokiti();
    try0 = true;
  }

  if (key == 'A' || key == 'a') {
    if (IMGboo == true) {
      IMGboo = false;
    } else if (IMGboo == false) {
      IMGboo = true;
      try7img=true;
      try11img=true;
      try12img=true;
    }
  } 
  if (key == 'Z' || key == 'z') {
    if (try7==true) {
      if (IMGboo == true) {
        IMGboo = false;
      } else if (IMGboo == false) {
        IMGboo = true;
        try7img=false;
      }
    }

    if (try11==true) {
      if (IMGboo == true) {
        IMGboo = false;
      } else if (IMGboo == false) {
        IMGboo = true;
        try11img=false;
      }
    }
    if (try12==true) {
      if (IMGboo == true) {
        IMGboo = false;
      } else if (IMGboo == false) {
        IMGboo = true;
        try12img=false;
      }
    }
  }
}  //end of keyPresse


void bond_clear() {
  //ブーレアン
  H1U1bond=false;
  H2U1bond=false;
  H3U1bond=false;
  H4U1bond=false;
  H5U1bond=false;
  H6U1bond=false;

  O1U1bond=false;
  O1U2bond=false;
  O2U1bond=false;
  O2U2bond=false;

  N1U1bond=false;
  N1U2bond=false;
  N1U3bond=false;
  N2U1bond=false;
  N2U2bond=false;
  N2U3bond=false;

  C1U1bond=false;
  C1U2bond=false;
  C1U3bond=false;
  C1U4bond=false;
  C2U1bond=false;
  C2U2bond=false;
  C2U3bond=false;
  C2U4bond=false;
}  //end of bond_clear


void shokiti() {
  //水素原子１
  H1X=70;
  H1Y=100+ 50*5;
  H1U1X=70 + 30*cos(PI);
  H1U1Y=100+ 50*5 + 30*sin(PI);
  //水素原子２
  H2X=70;
  H2Y=100 + 50*4;
  H2U1X=70 + 30*cos(PI);
  H2U1Y=100 + 50*4 + 30*sin(PI);
  //水素原子３
  H3X=70;
  H3Y=100 + 50*3;
  H3U1X=70 + 30*cos(PI);
  H3U1Y=100 + 50*3 + 30*sin(PI);   
  //水素原子４
  H4X=70;
  H4Y=100 + 50*2;
  H4U1X=70 + 30*cos(PI);
  H4U1Y=100 + 50*2  + 30*sin(PI);
  //水素原子５
  H5X=70;
  H5Y=100 + 50*1;
  H5U1X=70 + 30*cos(PI);
  H5U1Y=100 + 50*1 + 30*sin(PI);
  //水素原子６
  H6X=70;
  H6Y=100;
  H6U1X=70 + 30*cos(PI);
  H6U1Y=100 + 30*sin(PI);
  //酸素原子１
  O1X=70 +110*1;
  O1Y=185;
  O1U1X=70 + 110*1 + 40*cos(0);
  O1U1Y=185 + 40*sin(0);
  O1U2X=70 + 110*1 + 40*cos(PI);
  O1U2Y=185 + 40*sin(PI);
  //酸素原子２
  O2X=70 +110*1;
  O2Y=100;
  O2U1X=70 + 110*1 + 40*cos(0);
  O2U1Y=100 + 40*sin(0);
  O2U2X=70 + 110*1 + 40*cos(PI);
  O2U2Y=100 + 40*sin(PI);
  //窒素原子１
  N1X=70 + 110*2;
  N1Y=185;
  N1U1X=70 + 110*2+40*cos(0);
  N1U1Y=185 + 40*sin(0);
  N1U2X=70 + 110*2+40*cos(PI*2/3);
  N1U2Y=185 + 40*sin(PI*2/3);
  N1U3X=70 + 110*2+40*cos(PI*4/3);
  N1U3Y=185 + 40*sin(PI*4/3);
  //窒素原子２
  N2X=70 + 110*2;
  N2Y=100;
  N2U1X=70 + 110*2+40*cos(0);
  N2U1Y=100 + 40*sin(0);
  N2U2X=70 + 110*2+40*cos(PI*2/3);
  N2U2Y=100 + 40*sin(PI*2/3);
  N2U3X=70 + 110*2+40*cos(PI*4/3);
  N2U3Y=100 + 40*sin(PI*4/3);
  //炭素原子１
  C1X=70 + 110*3;
  C1Y=185;
  C1U1X=70 + 110*3+40*cos(0);
  C1U1Y=185 + 40*sin(0);
  C1U2X=70 + 110*3+40*cos(PI/2);
  C1U2Y=185 + 40*sin(PI/2);
  C1U3X=70 + 110*3+40*cos(PI);
  C1U3Y=185 + 40*sin(PI);
  C1U4X=70 + 110*3+40*cos(PI*3/2);
  C1U4Y=185 + 40*sin(PI*3/2);
  //炭素原子２
  C2X=70 + 110*3;
  C2Y=100;
  C2U1X=70 + 110*3+40*cos(0);
  C2U1Y=100 + 40*sin(0);
  C2U2X=70 + 110*3+40*cos(PI/2);
  C2U2Y=100 + 40*sin(PI/2);
  C2U3X=70 + 110*3+40*cos(PI);
  C2U3Y=100 + 40*sin(PI);
  C2U4X=70 + 110*3+40*cos(PI*3/2);
  C2U4Y=100 + 40*sin(PI*3/2);

  //腕の角度
  H1U1angle = PI;
  H2U1angle = PI;
  H3U1angle = PI;
  H4U1angle = PI;
  H5U1angle = PI;
  H6U1angle = PI;
  O1U1angle = 0;
  O1U2angle = PI;
  O2U1angle = 0;
  O2U2angle = PI;
  N1U1angle = 0;
  N1U2angle = PI*2/3;
  N1U3angle = -PI*2/3; 
  N2U1angle = 0;
  N2U2angle = PI*2/3;
  N2U3angle = -PI*2/3;
  C1U1angle = 0;
  C1U2angle = PI/2;
  C1U3angle = PI;
  C1U4angle = -PI/2;
  C2U1angle = 0;
  C2U2angle = PI/2;
  C2U3angle = PI;
  C2U4angle = -PI/2;

  //  try_clear
  try0=false;
  try1=false;
  try2=false;
  try3=false;
  try4=false;
  try5=false;
  try6=false;
  try7=false;
  try8=false;
  try9=false;
  try10=false;
  try11=false;
  try12=false;  

  i=0;
  IMGboo = false;
}  //end of shokiti


//以下、原子の結合の腕間検査用　
void HNbond() {
  //Hどうしは省略
  if (abs(H1U1X-N1U1X)<5 && abs(H1U1Y-N1U1Y)<5 && H1U1bond==false && N1U1bond==false ) {  //H1U1
    fill(255, 255, 0);
    noStroke();
    ellipse(H1U1X, H1U1Y, 10, 10);
    H1U1bond=true;
    N1U1bond=true;
  } else if (abs(H1U1X-N1U2X)<5 && abs(H1U1Y-N1U2Y)<5  && H1U1bond==false && N1U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H1U1X, H1U1Y, 10, 10);
    H1U1bond=true;
    N1U2bond=true;
  } else if (abs(H1U1X-N1U3X)<5 && abs(H1U1Y-N1U3Y)<5  && H1U1bond==false && N1U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H1U1X, H1U1Y, 10, 10);
    H1U1bond=true;
    N1U3bond=true;
  }

  if (abs(H2U1X-N1U1X)<5 && abs(H2U1Y-N1U1Y)<5 && H2U1bond==false && N1U1bond==false ) {  //H2U1
    fill(255, 255, 0);
    noStroke();
    ellipse(H2U1X, H2U1Y, 10, 10);
    H2U1bond=true;
    N1U1bond=true;
  } else if (abs(H2U1X-N1U2X)<5 && abs(H2U1Y-N1U2Y)<5  && H2U1bond==false && N1U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H2U1X, H2U1Y, 10, 10);
    H2U1bond=true;
    N1U2bond=true;
  } else if (abs(H2U1X-N1U3X)<5 && abs(H2U1Y-N1U3Y)<5  && H2U1bond==false && N1U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H2U1X, H2U1Y, 10, 10);
    H2U1bond=true;
    N1U3bond=true;
  }

  if (abs(H3U1X-N1U1X)<5 && abs(H3U1Y-N1U1Y)<5 && H3U1bond==false && N1U1bond==false ) {  //H3U1
    fill(255, 255, 0);
    noStroke();
    ellipse(H3U1X, H3U1Y, 10, 10);
    H3U1bond=true;
    N1U1bond=true;
  } else if (abs(H3U1X-N1U2X)<5 && abs(H3U1Y-N1U2Y)<5  && H3U1bond==false && N1U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H3U1X, H3U1Y, 10, 10);
    H3U1bond=true;
    N1U2bond=true;
  } else if (abs(H3U1X-N1U3X)<5 && abs(H3U1Y-N1U3Y)<5  && H3U1bond==false && N1U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H3U1X, H3U1Y, 10, 10);
    H3U1bond=true;
    N1U3bond=true;
  }
}  //end of  HNbond

void HCbond() {
  //Hどうしは省略
  if (abs(H1U1X-C1U1X)<5 && abs(H1U1Y-C1U1Y)<5 && H1U1bond==false && C1U1bond==false ) {  //H1U1-C1U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(H1U1X, H1U1Y, 10, 10);
    H1U1bond=true;
    C1U1bond=true;
  } else if (abs(H1U1X-C1U2X)<5 && abs(H1U1Y-C1U2Y)<5  && H1U1bond==false && C1U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H1U1X, H1U1Y, 10, 10);
    H1U1bond=true;
    C1U2bond=true;
  } else if (abs(H1U1X-C1U3X)<5 && abs(H1U1Y-C1U3Y)<5  && H1U1bond==false && C1U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H1U1X, H1U1Y, 10, 10);
    H1U1bond=true;
    C1U3bond=true;
  } else if (abs(H1U1X-C1U4X)<5 && abs(H1U1Y-C1U4Y)<5  && H1U1bond==false && C1U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H1U1X, H1U1Y, 10, 10);
    H1U1bond=true;
    C1U4bond=true;
  }

  if (abs(H2U1X-C1U1X)<5 && abs(H2U1Y-C1U1Y)<5 && H2U1bond==false && C1U1bond==false ) {  //H2U1-C1U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(H2U1X, H2U1Y, 10, 10);
    H2U1bond=true;
    C1U1bond=true;
  } else if (abs(H2U1X-C1U2X)<5 && abs(H2U1Y-C1U2Y)<5  && H2U1bond==false && C1U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H2U1X, H2U1Y, 10, 10);
    H2U1bond=true;
    C1U2bond=true;
  } else if (abs(H2U1X-C1U3X)<5 && abs(H2U1Y-C1U3Y)<5  && H2U1bond==false && C1U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H2U1X, H2U1Y, 10, 10);
    H2U1bond=true;
    C1U3bond=true;
  } else if (abs(H2U1X-C1U4X)<5 && abs(H2U1Y-C1U4Y)<5  && H2U1bond==false && C1U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H2U1X, H2U1Y, 10, 10);
    H2U1bond=true;
    C1U4bond=true;
  }

  if (abs(H3U1X-C1U1X)<5 && abs(H3U1Y-C1U1Y)<5 && H3U1bond==false && C1U1bond==false ) {  //H3U1-C1U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(H3U1X, H3U1Y, 10, 10);
    H3U1bond=true;
    C1U1bond=true;
  } else if (abs(H3U1X-C1U2X)<5 && abs(H3U1Y-C1U2Y)<5  && H3U1bond==false && C1U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H3U1X, H3U1Y, 10, 10);
    H3U1bond=true;
    C1U2bond=true;
  } else if (abs(H3U1X-C1U3X)<5 && abs(H3U1Y-C1U3Y)<5  && H3U1bond==false && C1U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H3U1X, H3U1Y, 10, 10);
    H3U1bond=true;
    C1U3bond=true;
  } else if (abs(H3U1X-C1U4X)<5 && abs(H3U1Y-C1U4Y)<5  && H3U1bond==false && C1U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H3U1X, H3U1Y, 10, 10);
    H3U1bond=true;
    C1U4bond=true;
  } 

  if (abs(H4U1X-C1U1X)<5 && abs(H4U1Y-C1U1Y)<5 && H4U1bond==false && C1U1bond==false ) {  //H4U1-C1U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(H4U1X, H4U1Y, 10, 10);
    H4U1bond=true;
    C1U1bond=true;
  } else if (abs(H4U1X-C1U2X)<5 && abs(H4U1Y-C1U2Y)<5  && H4U1bond==false && C1U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H4U1X, H4U1Y, 10, 10);
    H4U1bond=true;
    C1U2bond=true;
  } else if (abs(H4U1X-C1U3X)<5 && abs(H4U1Y-C1U3Y)<5  && H4U1bond==false && C1U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H4U1X, H4U1Y, 10, 10);
    H4U1bond=true;
    C1U3bond=true;
  } else if (abs(H4U1X-C1U4X)<5 && abs(H4U1Y-C1U4Y)<5  && H4U1bond==false && C1U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H4U1X, H4U1Y, 10, 10);
    H4U1bond=true;
    C1U4bond=true;
  }

  if (abs(H5U1X-C1U1X)<5 && abs(H5U1Y-C1U1Y)<5 && H5U1bond==false && C1U1bond==false ) {  //H5U1-C1U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(H5U1X, H5U1Y, 10, 10);
    H5U1bond=true;
    C1U1bond=true;
  } else if (abs(H5U1X-C1U2X)<5 && abs(H5U1Y-C1U2Y)<5  && H5U1bond==false && C1U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H5U1X, H5U1Y, 10, 10);
    H5U1bond=true;
    C1U2bond=true;
  } else if (abs(H5U1X-C1U3X)<5 && abs(H5U1Y-C1U3Y)<5  && H5U1bond==false && C1U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H5U1X, H5U1Y, 10, 10);
    H4U1bond=true;
    C1U3bond=true;
  } else if (abs(H5U1X-C1U4X)<5 && abs(H5U1Y-C1U4Y)<5  && H5U1bond==false && C1U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H5U1X, H5U1Y, 10, 10);
    H5U1bond=true;
    C1U4bond=true;
  }  

  if (abs(H6U1X-C1U1X)<5 && abs(H6U1Y-C1U1Y)<5 && H6U1bond==false && C1U1bond==false ) {  //H6U1-C1U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(H6U1X, H6U1Y, 10, 10);
    H6U1bond=true;
    C1U1bond=true;
  } else if (abs(H6U1X-C1U2X)<5 && abs(H6U1Y-C1U2Y)<5  && H6U1bond==false && C1U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H6U1X, H6U1Y, 10, 10);
    H6U1bond=true;
    C1U2bond=true;
  } else if (abs(H6U1X-C1U3X)<5 && abs(H6U1Y-C1U3Y)<5  && H6U1bond==false && C1U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H6U1X, H6U1Y, 10, 10);
    H6U1bond=true;
    C1U3bond=true;
  } else if (abs(H6U1X-C1U4X)<5 && abs(H6U1Y-C1U4Y)<5  && H6U1bond==false && C1U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H6U1X, H6U1Y, 10, 10);
    H6U1bond=true;
    C1U4bond=true;
  } 

  if (abs(H1U1X-C2U1X)<5 && abs(H1U1Y-C2U1Y)<5 && H1U1bond==false && C2U1bond==false ) {  //H1U1-C2U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(H1U1X, H1U1Y, 10, 10);
    H1U1bond=true;
    C2U1bond=true;
  } else if (abs(H1U1X-C2U2X)<5 && abs(H1U1Y-C2U2Y)<5  && H1U1bond==false && C2U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H1U1X, H1U1Y, 10, 10);
    H1U1bond=true;
    C2U2bond=true;
  } else if (abs(H1U1X-C2U3X)<5 && abs(H1U1Y-C2U3Y)<5  && H1U1bond==false && C2U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H1U1X, H1U1Y, 10, 10);
    H1U1bond=true;
    C2U3bond=true;
  } else if (abs(H1U1X-C2U4X)<5 && abs(H1U1Y-C2U4Y)<5  && H1U1bond==false && C2U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H1U1X, H1U1Y, 10, 10);
    H1U1bond=true;
    C2U4bond=true;
  }

  if (abs(H2U1X-C2U1X)<5 && abs(H2U1Y-C2U1Y)<5 && H2U1bond==false && C2U1bond==false ) {  //H2U1-C2U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(H2U1X, H2U1Y, 10, 10);
    H2U1bond=true;
    C2U1bond=true;
  } else if (abs(H2U1X-C2U2X)<5 && abs(H2U1Y-C2U2Y)<5  && H2U1bond==false && C2U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H2U1X, H2U1Y, 10, 10);
    H2U1bond=true;
    C2U2bond=true;
  } else if (abs(H2U1X-C2U3X)<5 && abs(H2U1Y-C2U3Y)<5  && H2U1bond==false && C2U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H2U1X, H2U1Y, 10, 10);
    H2U1bond=true;
    C2U3bond=true;
  } else if (abs(H2U1X-C2U4X)<5 && abs(H2U1Y-C2U4Y)<5  && H2U1bond==false && C2U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H2U1X, H2U1Y, 10, 10);
    H2U1bond=true;
    C2U4bond=true;
  }

  if (abs(H3U1X-C2U1X)<5 && abs(H3U1Y-C2U1Y)<5 && H3U1bond==false && C2U1bond==false ) {  //H3U1-C2U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(H3U1X, H3U1Y, 10, 10);
    H3U1bond=true;
    C2U1bond=true;
  } else if (abs(H3U1X-C2U2X)<5 && abs(H3U1Y-C2U2Y)<5  && H3U1bond==false && C2U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H3U1X, H3U1Y, 10, 10);
    H3U1bond=true;
    C2U2bond=true;
  } else if (abs(H3U1X-C2U3X)<5 && abs(H3U1Y-C2U3Y)<5  && H3U1bond==false && C2U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H3U1X, H3U1Y, 10, 10);
    H3U1bond=true;
    C2U3bond=true;
  } else if (abs(H3U1X-C2U4X)<5 && abs(H3U1Y-C2U4Y)<5  && H3U1bond==false && C2U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H3U1X, H3U1Y, 10, 10);
    H3U1bond=true;
    C2U4bond=true;
  } 

  if (abs(H4U1X-C2U1X)<5 && abs(H4U1Y-C2U1Y)<5 && H4U1bond==false && C2U1bond==false ) {  //H4U1-C2U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(H4U1X, H4U1Y, 10, 10);
    H4U1bond=true;
    C2U1bond=true;
  } else if (abs(H4U1X-C2U2X)<5 && abs(H4U1Y-C2U2Y)<5  && H4U1bond==false && C2U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H4U1X, H4U1Y, 10, 10);
    H4U1bond=true;
    C2U2bond=true;
  } else if (abs(H4U1X-C2U3X)<5 && abs(H4U1Y-C2U3Y)<5  && H4U1bond==false && C2U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H4U1X, H4U1Y, 10, 10);
    H4U1bond=true;
    C2U3bond=true;
  } else if (abs(H4U1X-C2U4X)<5 && abs(H4U1Y-C2U4Y)<5  && H4U1bond==false && C2U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H4U1X, H4U1Y, 10, 10);
    H4U1bond=true;
    C2U4bond=true;
  }

  if (abs(H5U1X-C2U1X)<5 && abs(H5U1Y-C2U1Y)<5 && H5U1bond==false && C2U1bond==false ) {  //H5U1-C2U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(H5U1X, H5U1Y, 10, 10);
    H5U1bond=true;
    C2U1bond=true;
  } else if (abs(H5U1X-C2U2X)<5 && abs(H5U1Y-C2U2Y)<5  && H5U1bond==false && C2U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H5U1X, H5U1Y, 10, 10);
    H5U1bond=true;
    C2U2bond=true;
  } else if (abs(H5U1X-C2U3X)<5 && abs(H5U1Y-C2U3Y)<5  && H5U1bond==false && C2U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H5U1X, H5U1Y, 10, 10);
    H4U1bond=true;
    C2U3bond=true;
  } else if (abs(H5U1X-C2U4X)<5 && abs(H5U1Y-C2U4Y)<5  && H5U1bond==false && C2U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H5U1X, H5U1Y, 10, 10);
    H5U1bond=true;
    C2U4bond=true;
  }  

  if (abs(H6U1X-C2U1X)<5 && abs(H6U1Y-C2U1Y)<5 && H6U1bond==false && C2U1bond==false ) {  //H6U1-C2U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(H6U1X, H6U1Y, 10, 10);
    H6U1bond=true;
    C2U1bond=true;
  } else if (abs(H6U1X-C2U2X)<5 && abs(H6U1Y-C2U2Y)<5  && H6U1bond==false && C2U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H6U1X, H6U1Y, 10, 10);
    H6U1bond=true;
    C2U2bond=true;
  } else if (abs(H6U1X-C2U3X)<5 && abs(H6U1Y-C2U3Y)<5  && H6U1bond==false && C2U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H6U1X, H6U1Y, 10, 10);
    H6U1bond=true;
    C2U3bond=true;
  } else if (abs(H6U1X-C2U4X)<5 && abs(H6U1Y-C2U4Y)<5  && H6U1bond==false && C2U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H6U1X, H6U1Y, 10, 10);
    H6U1bond=true;
    C2U4bond=true;
  }
}   //end of HCbond


void NCbond() {
  if (abs(N1U1X-C1U1X)<5 && abs(N1U1Y-C1U1Y)<5 && N1U1bond==false && C1U1bond==false ) {  //N1U1-C1U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(N1U1X, N1U1Y, 10, 10);
    N1U1bond=true;
    C1U1bond=true;
  } else if (abs(N1U1X-C1U2X)<5 && abs(N1U1Y-C1U2Y)<5  && N1U1bond==false && C1U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(N1U1X, N1U1Y, 10, 10);
    N1U1bond=true;
    C1U2bond=true;
  } else if (abs(N1U1X-C1U3X)<5 && abs(N1U1Y-C1U3Y)<5  && N1U1bond==false && C1U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(N1U1X, N1U1Y, 10, 10);
    N1U1bond=true;
    C1U3bond=true;
  } else if (abs(N1U1X-C1U4X)<5 && abs(N1U1Y-C1U4Y)<5  && N1U1bond==false && C1U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(N1U1X, N1U1Y, 10, 10);
    N1U1bond=true;
    C1U4bond=true;
  }

  if (abs(N1U2X-C1U1X)<5 && abs(N1U2Y-C1U1Y)<5 && N1U2bond==false && C1U1bond==false ) {  //N1U2-C1U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(N1U2X, N1U2Y, 10, 10);
    N1U2bond=true;
    C1U1bond=true;
  } else if (abs(N1U2X-C1U2X)<5 && abs(N1U2Y-C1U2Y)<5  && N1U2bond==false && C1U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(N1U2X, N1U2Y, 10, 10);
    N1U2bond=true;
    C1U2bond=true;
  } else if (abs(N1U2X-C1U3X)<5 && abs(N1U2Y-C1U3Y)<5  && N1U2bond==false && C1U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(N1U2X, N1U2Y, 10, 10);
    N1U2bond=true;
    C1U3bond=true;
  } else if (abs(N1U2X-C1U4X)<5 && abs(N1U2Y-C1U4Y)<5  && N1U2bond==false && C1U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(N1U2X, N1U2Y, 10, 10);
    N1U2bond=true;
    C1U4bond=true;
  }

  if (abs(N1U3X-C1U1X)<5 && abs(N1U3Y-C1U1Y)<5 && N1U3bond==false && C1U1bond==false ) {  //N1U3-C1U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(N1U3X, N1U3Y, 10, 10);
    N1U3bond=true;
    C1U1bond=true;
  } else if (abs(N1U3X-C1U2X)<5 && abs(N1U3Y-C1U2Y)<5  && N1U3bond==false && C1U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(N1U3X, N1U3Y, 10, 10);
    N1U3bond=true;
    C1U2bond=true;
  } else if (abs(N1U3X-C1U3X)<5 && abs(N1U3Y-C1U3Y)<5  && N1U3bond==false && C1U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(N1U3X, N1U3Y, 10, 10);
    N1U3bond=true;
    C1U3bond=true;
  } else if (abs(N1U3X-C1U4X)<5 && abs(N1U3Y-C1U4Y)<5  && N1U3bond==false && C1U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(N1U3X, N1U3Y, 10, 10);
    N1U3bond=true;
    C1U4bond=true;
  }
}  //end of NCbond


void CCbond() {
  if (abs(C1U1X-C2U1X)<5 && abs(C1U1Y-C2U1Y)<5 && C1U1bond==false && C2U1bond==false ) {  //C1U1-C2U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(C1U1X, C1U1Y, 10, 10);
    C1U1bond=true;
    C2U1bond=true;
  } else if (abs(C1U1X-C2U2X)<5 && abs(C1U1Y-C2U2Y)<5  && C1U1bond==false && C2U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(C1U1X, C1U1Y, 10, 10);
    C1U1bond=true;
    C2U2bond=true;
  } else if (abs(C1U1X-C2U3X)<5 && abs(C1U1Y-C2U3Y)<5  && C1U1bond==false && C2U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(C1U1X, C1U1Y, 10, 10);
    C1U1bond=true;
    C2U3bond=true;
  } else if (abs(C1U1X-C2U4X)<5 && abs(C1U1Y-C2U4Y)<5  && C1U1bond==false && C2U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(C1U1X, C1U1Y, 10, 10);
    C1U1bond=true;
    C2U4bond=true;
  }

  if (abs(C1U2X-C2U1X)<5 && abs(C1U2Y-C2U1Y)<5 && C1U2bond==false && C2U1bond==false ) {  //C1U2-C2U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(C1U2X, C1U2Y, 10, 10);
    C1U2bond=true;
    C2U1bond=true;
  } else if (abs(C1U2X-C2U2X)<5 && abs(C1U2Y-C2U2Y)<5  && C1U2bond==false && C2U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(C1U2X, C1U2Y, 10, 10);
    C1U2bond=true;
    C2U2bond=true;
  } else if (abs(C1U2X-C2U3X)<5 && abs(C1U2Y-C2U3Y)<5  && C1U2bond==false && C2U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(C1U2X, C1U2Y, 10, 10);
    C1U2bond=true;
    C2U3bond=true;
  } else if (abs(C1U2X-C2U4X)<5 && abs(C1U2Y-C2U4Y)<5  && C1U2bond==false && C2U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(C1U2X, C1U2Y, 10, 10);
    C1U2bond=true;
    C2U4bond=true;
  }

  if (abs(C1U3X-C2U1X)<5 && abs(C1U3Y-C2U1Y)<5 && C1U3bond==false && C2U1bond==false ) {  //C1U3-C2U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(C1U3X, C1U3Y, 10, 10);
    C1U3bond=true;
    C2U1bond=true;
  } else if (abs(C1U3X-C2U2X)<5 && abs(C1U3Y-C2U2Y)<5  && C1U3bond==false && C2U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(C1U3X, C1U3Y, 10, 10);
    C1U3bond=true;
    C2U2bond=true;
  } else if (abs(C1U3X-C2U3X)<5 && abs(C1U3Y-C2U3Y)<5  && C1U3bond==false && C2U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(C1U3X, C1U3Y, 10, 10);
    C1U3bond=true;
    C2U3bond=true;
  } else if (abs(C1U3X-C2U4X)<5 && abs(C1U3Y-C2U4Y)<5  && C1U3bond==false && C2U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(C1U3X, C1U3Y, 10, 10);
    C1U3bond=true;
    C2U4bond=true;
  }

  if (abs(C1U4X-C2U1X)<5 && abs(C1U4Y-C2U1Y)<5 && C1U4bond==false && C2U1bond==false ) {  //C1U4-C2U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(C1U4X, C1U4Y, 10, 10);
    C1U4bond=true;
    C2U1bond=true;
  } else if (abs(C1U4X-C2U2X)<5 && abs(C1U4Y-C2U2Y)<5  && C1U4bond==false && C2U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(C1U4X, C1U4Y, 10, 10);
    C1U4bond=true;
    C2U2bond=true;
  } else if (abs(C1U4X-C2U3X)<5 && abs(C1U4Y-C2U3Y)<5  && C1U4bond==false && C2U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(C1U4X, C1U4Y, 10, 10);
    C1U4bond=true;
    C2U3bond=true;
  } else if (abs(C1U4X-C2U4X)<5 && abs(C1U4Y-C2U4Y)<5  && C1U4bond==false && C2U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(C1U4X, C1U4Y, 10, 10);
    C1U4bond=true;
    C2U4bond=true;
  }
}  //end of CCbond


void NNbond() {
  if (abs(N1U1X-N2U1X)<5 && abs(N1U1Y-N2U1Y)<5 && N1U1bond==false && N2U1bond==false ) {  //N1U1
    fill(255, 255, 0);
    noStroke();
    ellipse(N1U1X, N1U1Y, 10, 10);
    N1U1bond=true;
    N2U1bond=true;
  } else if (abs(N1U1X-N2U2X)<5 && abs(N1U1Y-N2U2Y)<5  && N1U1bond==false && N2U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(N1U1X, N1U1Y, 10, 10);
    N1U1bond=true;
    N2U2bond=true;
  } else if (abs(N1U1X-N2U3X)<5 && abs(N1U1Y-N2U3Y)<5  && N1U1bond==false && N2U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(N1U1X, N1U1Y, 10, 10);
    N1U1bond=true;
    N2U3bond=true;
  }

  if (abs(N1U2X-N2U1X)<5 && abs(N1U2Y-N2U1Y)<5 && N1U2bond==false && N2U1bond==false) {  //N1U2
    fill(255, 255, 0);
    noStroke();
    ellipse(N1U2X, N1U2Y, 10, 10);
    N1U2bond=true;
    N2U1bond=true;
  } else if (abs(N1U2X-N2U2X)<5 && abs(N1U2Y-N2U2Y)<5  && N1U2bond==false && N2U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(N1U2X, N1U2Y, 10, 10);
    N1U2bond=true;
    N2U2bond=true;
  } else if (abs(N1U2X-N2U3X)<5 && abs(N1U2Y-N2U3Y)<5  && N1U2bond==false && N2U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(N1U2X, N1U2Y, 10, 10);
    N1U2bond=true;
    N2U3bond=true;
  }

  if (abs(N1U3X-N2U1X)<5 && abs(N1U3Y-N2U1Y)<5  && N1U3bond==false && N2U1bond==false) {  //N1U3
    fill(255, 255, 0);
    noStroke();
    ellipse(N1U3X, N1U3Y, 10, 10);
    N1U3bond=true;
    N2U1bond=true;
  } else if (abs(N1U3X-N2U2X)<5 && abs(N1U3Y-N2U2Y)<5  && N1U3bond==false && N2U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(N1U3X, N1U3Y, 10, 10);
    N1U3bond=true;
    N2U2bond=true;
  } else if (abs(N1U3X-N2U3X)<5 && abs(N1U3Y-N2U3Y)<5  && N1U3bond==false && N2U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(N1U3X, N1U3Y, 10, 10);
    N1U3bond=true;
    N2U3bond=true;
  }
}  //end of NNbond


void OObond() {
  if (abs(O1U1X-O2U1X)<5 && abs(O1U1Y-O2U1Y)<5 && O1U1bond==false && O2U1bond==false ) {  //O1U1-O2U12
    fill(255, 255, 0);
    noStroke();
    ellipse(O1U1X, O1U1Y, 10, 10);
    O1U1bond=true;
    O2U1bond=true;
  } else if (abs(O1U1X-O2U2X)<5 && abs(O1U1Y-O2U2Y)<5  && O1U1bond==false && O2U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O1U1X, O1U1Y, 10, 10);
    O1U1bond=true;
    O2U2bond=true;
  } 

  if (abs(O1U2X-O2U1X)<5 && abs(O1U2Y-O2U1Y)<5 && O1U2bond==false && O2U1bond==false) {  //O1U2-O2U12
    fill(255, 255, 0);
    noStroke();
    ellipse(O1U2X, O1U2Y, 10, 10);
    O1U2bond=true;
    O2U1bond=true;
  } else if (abs(O1U2X-O2U2X)<5 && abs(O1U2Y-O2U2Y)<5  && O1U2bond==false && O2U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O1U2X, O1U2Y, 10, 10);
    O1U2bond=true;
    O2U2bond=true;
  }
}   //end of OObond


void HObond() {
  if (abs(H1U1X-H2U1X)<5 && abs(H1U1Y-H2U1Y)<5) {  //H-H bond
    fill(255, 255, 0);
    noStroke();
    ellipse(H1U1X, H1U1Y, 10, 10);
  }

  if (abs(H1U1X-O1U1X)<5 && abs(H1U1Y-O1U1Y)<5) {  //H1U1-O1U12
    fill(255, 255, 0);
    noStroke();
    ellipse(H1U1X, H1U1Y, 10, 10);
    H1U1bond=true;
    O1U1bond=true;
    HOlink=true;
  } else if (abs(H1U1X-O1U2X)<5 && abs(H1U1Y-O1U2Y)<5) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H1U1X, H1U1Y, 10, 10); 
    H1U1bond=true;
    O1U2bond=true;
    HOlink=true;
  }    
  if (abs(H2U1X-O1U1X)<5 && abs(H2U1Y-O1U1Y)<5) {  //H2U1-O1U12
    fill(255, 255, 0);
    noStroke();
    ellipse(H2U1X, H2U1Y, 10, 10);
    H2U1bond=true;
    O1U1bond=true;
    HOlink=true;
  } else if (abs(H2U1X-O1U2X)<5 && abs(H2U1Y-O1U2Y)<5) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H2U1X, H2U1Y, 10, 10);
    H2U1bond=true;
    O1U2bond=true;
    HOlink=true;
  }

  if (abs(H3U1X-O1U1X)<5 && abs(H3U1Y-O1U1Y)<5) {  //H3U1-O1U12
    fill(255, 255, 0);
    noStroke();
    ellipse(H3U1X, H3U1Y, 10, 10);
    H3U1bond=true;
    O1U1bond=true;
    HOlink=true;
  } else if (abs(H3U1X-O1U2X)<5 && abs(H3U1Y-O1U2Y)<5) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H3U1X, H3U1Y, 10, 10); 
    H3U1bond=true;
    O1U2bond=true;
    HOlink=true;
  }

  if (abs(H4U1X-O1U1X)<5 && abs(H4U1Y-O1U1Y)<5) {  //H4U1-O1U12
    fill(255, 255, 0);
    noStroke();
    ellipse(H4U1X, H4U1Y, 10, 10);
    H4U1bond=true;
    O1U1bond=true;
    HOlink=true;
  } else if (abs(H4U1X-O1U2X)<5 && abs(H4U1Y-O1U2Y)<5) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H4U1X, H4U1Y, 10, 10); 
    H4U1bond=true;
    O1U2bond=true;
    HOlink=true;
  }

  if (abs(H5U1X-O1U1X)<5 && abs(H5U1Y-O1U1Y)<5) {  //H5U1-O1U12
    fill(255, 255, 0);
    noStroke();
    ellipse(H5U1X, H5U1Y, 10, 10);
    H5U1bond=true;
    O1U1bond=true;
    HOlink=true;
  } else if (abs(H5U1X-O1U2X)<5 && abs(H5U1Y-O1U2Y)<5) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H5U1X, H5U1Y, 10, 10); 
    H5U1bond=true;
    O1U2bond=true;
    HOlink=true;
  }  

  if (abs(H6U1X-O1U1X)<5 && abs(H6U1Y-O1U1Y)<5) {  //H6U1-O1U12
    fill(255, 255, 0);
    noStroke();
    ellipse(H6U1X, H6U1Y, 10, 10);
    H6U1bond=true;
    O1U1bond=true;
    HOlink=true;
  } else if (abs(H6U1X-O1U2X)<5 && abs(H6U1Y-O1U2Y)<5) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H6U1X, H6U1Y, 10, 10); 
    H6U1bond=true;
    O1U2bond=true;
    HOlink=true;
  }

  if (abs(H1U1X-O2U1X)<5 && abs(H1U1Y-O2U1Y)<5) {  //H1U1-O2U12
    fill(255, 255, 0);
    noStroke();
    ellipse(H1U1X, H1U1Y, 10, 10);
    H1U1bond=true;
    O2U1bond=true;
    HOlink=true;
  } else if (abs(H1U1X-O2U2X)<5 && abs(H1U1Y-O2U2Y)<5) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H1U1X, H1U1Y, 10, 10); 
    H1U1bond=true;
    O2U2bond=true;
    HOlink=true;
  }    
  if (abs(H2U1X-O2U1X)<5 && abs(H2U1Y-O2U1Y)<5) {  //H2U1-O2U12
    fill(255, 255, 0);
    noStroke();
    ellipse(H2U1X, H2U1Y, 10, 10);
    H2U1bond=true;
    O2U1bond=true;
    HOlink=true;
  } else if (abs(H2U1X-O2U2X)<5 && abs(H2U1Y-O2U2Y)<5) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H2U1X, H2U1Y, 10, 10);
    H2U1bond=true;
    O2U2bond=true;
    HOlink=true;
  }

  if (abs(H3U1X-O2U1X)<5 && abs(H3U1Y-O2U1Y)<5) {  //H3U1-O2U12
    fill(255, 255, 0);
    noStroke();
    ellipse(H3U1X, H3U1Y, 10, 10);
    H3U1bond=true;
    O2U1bond=true;
    HOlink=true;
  } else if (abs(H3U1X-O2U2X)<5 && abs(H3U1Y-O2U2Y)<5) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H3U1X, H3U1Y, 10, 10); 
    H3U1bond=true;
    O2U2bond=true;
    HOlink=true;
  }

  if (abs(H4U1X-O2U1X)<5 && abs(H4U1Y-O2U1Y)<5) {  //H4U1-O2U12
    fill(255, 255, 0);
    noStroke();
    ellipse(H4U1X, H4U1Y, 10, 10);
    H4U1bond=true;
    O2U1bond=true;
    HOlink=true;
  } else if (abs(H4U1X-O2U2X)<5 && abs(H4U1Y-O2U2Y)<5) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H4U1X, H4U1Y, 10, 10); 
    H4U1bond=true;
    O2U2bond=true;
    HOlink=true;
  }

  if (abs(H5U1X-O2U1X)<5 && abs(H5U1Y-O2U1Y)<5) {  //H5U1-O2U12
    fill(255, 255, 0);
    noStroke();
    ellipse(H5U1X, H5U1Y, 10, 10);
    H5U1bond=true;
    O2U1bond=true;
    HOlink=true;
  } else if (abs(H5U1X-O2U2X)<5 && abs(H5U1Y-O2U2Y)<5) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H5U1X, H5U1Y, 10, 10); 
    H5U1bond=true;
    O2U2bond=true;
    HOlink=true;
  }  

  if (abs(H6U1X-O2U1X)<5 && abs(H6U1Y-O2U1Y)<5) {  //H6U1-O2U12
    fill(255, 255, 0);
    noStroke();
    ellipse(H6U1X, H6U1Y, 10, 10);
    H6U1bond=true;
    O2U1bond=true;
    HOlink=true;
  } else if (abs(H6U1X-O2U2X)<5 && abs(H6U1Y-O2U2Y)<5) {
    fill(255, 255, 0);
    noStroke();
    ellipse(H6U1X, H6U1Y, 10, 10); 
    H6U1bond=true;
    O2U2bond=true;
    HOlink=true;
  }
}  //end of HObond


void OCbond() {
  if (abs(O1U1X-C1U1X)<5 && abs(O1U1Y-C1U1Y)<5 && O1U1bond==false && C1U1bond==false ) {  //O1U1-C1U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(O1U1X, O1U1Y, 10, 10);
    O1U1bond=true;
    C1U1bond=true;
  } else if (abs(O1U1X-C1U2X)<5 && abs(O1U1Y-C1U2Y)<5  && O1U1bond==false && C1U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O1U1X, O1U1Y, 10, 10);
    O1U1bond=true;
    C1U2bond=true;
  } else if (abs(O1U1X-C1U3X)<5 && abs(O1U1Y-C1U3Y)<5  && O1U1bond==false && C1U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O1U1X, O1U1Y, 10, 10);
    O1U1bond=true;
    C1U3bond=true;
  } else if (abs(O1U1X-C1U4X)<5 && abs(O1U1Y-C1U4Y)<5  && O1U1bond==false && C1U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O1U1X, O1U1Y, 10, 10);
    O1U1bond=true;
    C1U4bond=true;
  } 

  if (abs(O1U2X-C1U1X)<5 && abs(O1U2Y-C1U1Y)<5 && O1U2bond==false && C1U1bond==false ) {  //O1U2-C1U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(O1U2X, O1U2Y, 10, 10);
    O1U2bond=true;
    C1U1bond=true;
  } else if (abs(O1U2X-C1U2X)<5 && abs(O1U2Y-C1U2Y)<5  && O1U2bond==false && C1U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O1U2X, O1U2Y, 10, 10);
    O1U2bond=true;
    C1U2bond=true;
  } else if (abs(O1U2X-C1U3X)<5 && abs(O1U2Y-C1U3Y)<5  && O1U2bond==false && C1U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O1U2X, O1U2Y, 10, 10);
    O1U2bond=true;
    C1U3bond=true;
  } else if (abs(O1U2X-C1U4X)<5 && abs(O1U2Y-C1U4Y)<5  && O1U2bond==false && C1U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O1U2X, O1U2Y, 10, 10);
    O1U2bond=true;
    C1U4bond=true;
  }

  if (abs(O1U1X-C2U1X)<5 && abs(O1U1Y-C2U1Y)<5 && O1U1bond==false && C2U1bond==false ) {  //O1U1-C2U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(O1U1X, O1U1Y, 10, 10);
    O1U1bond=true;
    C2U1bond=true;
  } else if (abs(O1U1X-C2U2X)<5 && abs(O1U1Y-C2U2Y)<5  && O1U1bond==false && C2U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O1U1X, O1U1Y, 10, 10);
    O1U1bond=true;
    C2U2bond=true;
  } else if (abs(O1U1X-C2U3X)<5 && abs(O1U1Y-C2U3Y)<5  && O1U1bond==false && C2U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O1U1X, O1U1Y, 10, 10);
    O1U1bond=true;
    C2U3bond=true;
  } else if (abs(O1U1X-C2U4X)<5 && abs(O1U1Y-C2U4Y)<5  && O1U1bond==false && C2U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O1U1X, O1U1Y, 10, 10);
    O1U1bond=true;
    C2U4bond=true;
  } 

  if (abs(O1U2X-C2U1X)<5 && abs(O1U2Y-C2U1Y)<5 && O1U2bond==false && C2U1bond==false ) {  //O1U2-C2U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(O1U2X, O1U2Y, 10, 10);
    O1U2bond=true;
    C2U1bond=true;
  } else if (abs(O1U2X-C2U2X)<5 && abs(O1U2Y-C2U2Y)<5  && O1U2bond==false && C2U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O1U2X, O1U2Y, 10, 10);
    O1U2bond=true;
    C2U2bond=true;
  } else if (abs(O1U2X-C2U3X)<5 && abs(O1U2Y-C2U3Y)<5  && O1U2bond==false && C2U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O1U2X, O1U2Y, 10, 10);
    O1U2bond=true;
    C2U3bond=true;
  } else if (abs(O1U2X-C2U4X)<5 && abs(O1U2Y-C2U4Y)<5  && O1U2bond==false && C2U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O1U2X, O1U2Y, 10, 10);
    O1U2bond=true;
    C2U4bond=true;
  }

  if (abs(O2U1X-C1U1X)<5 && abs(O2U1Y-C1U1Y)<5 && O2U1bond==false && C1U1bond==false ) {  //O2U1-C1U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(O2U1X, O2U1Y, 10, 10);
    O2U1bond=true;
    C1U1bond=true;
  } else if (abs(O2U1X-C1U2X)<5 && abs(O2U1Y-C1U2Y)<5  && O2U1bond==false && C1U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O2U1X, O2U1Y, 10, 10);
    O2U1bond=true;
    C1U2bond=true;
  } else if (abs(O2U1X-C1U3X)<5 && abs(O2U1Y-C1U3Y)<5  && O2U1bond==false && C1U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O2U1X, O2U1Y, 10, 10);
    O2U1bond=true;
    C1U3bond=true;
  } else if (abs(O2U1X-C1U4X)<5 && abs(O2U1Y-C1U4Y)<5  && O2U1bond==false && C1U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O2U1X, O2U1Y, 10, 10);
    O2U1bond=true;
    C1U4bond=true;
  } 

  if (abs(O2U2X-C1U1X)<5 && abs(O2U2Y-C1U1Y)<5 && O2U2bond==false && C1U1bond==false ) {  //O2U2-C1U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(O2U2X, O2U2Y, 10, 10);
    O2U2bond=true;
    C1U1bond=true;
  } else if (abs(O2U2X-C1U2X)<5 && abs(O2U2Y-C1U2Y)<5  && O2U2bond==false && C1U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O2U2X, O2U2Y, 10, 10);
    O2U2bond=true;
    C1U2bond=true;
  } else if (abs(O2U2X-C1U3X)<5 && abs(O2U2Y-C1U3Y)<5  && O2U2bond==false && C1U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O2U2X, O2U2Y, 10, 10);
    O2U2bond=true;
    C1U3bond=true;
  } else if (abs(O2U2X-C1U4X)<5 && abs(O2U2Y-C1U4Y)<5  && O2U2bond==false && C1U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O2U2X, O2U2Y, 10, 10);
    O2U2bond=true;
    C1U4bond=true;
  }

  if (abs(O2U1X-C2U1X)<5 && abs(O2U1Y-C2U1Y)<5 && O2U1bond==false && C2U1bond==false ) {  //O2U1-C2U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(O2U1X, O2U1Y, 10, 10);
    O2U1bond=true;
    C2U1bond=true;
  } else if (abs(O2U1X-C2U2X)<5 && abs(O2U1Y-C2U2Y)<5  && O2U1bond==false && C2U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O2U1X, O2U1Y, 10, 10);
    O2U1bond=true;
    C2U2bond=true;
  } else if (abs(O2U1X-C2U3X)<5 && abs(O2U1Y-C2U3Y)<5  && O2U1bond==false && C2U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O2U1X, O2U1Y, 10, 10);
    O2U1bond=true;
    C2U3bond=true;
  } else if (abs(O2U1X-C2U4X)<5 && abs(O2U1Y-C2U4Y)<5  && O2U1bond==false && C2U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O2U1X, O2U1Y, 10, 10);
    O2U1bond=true;
    C2U4bond=true;
  } 

  if (abs(O2U2X-C2U1X)<5 && abs(O2U2Y-C2U1Y)<5 && O2U2bond==false && C2U1bond==false ) {  //O2U2-C2U1234
    fill(255, 255, 0);
    noStroke();
    ellipse(O2U2X, O2U2Y, 10, 10);
    O2U2bond=true;
    C2U1bond=true;
  } else if (abs(O2U2X-C2U2X)<5 && abs(O2U2Y-C2U2Y)<5  && O2U2bond==false && C2U2bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O2U2X, O2U2Y, 10, 10);
    O2U2bond=true;
    C2U2bond=true;
  } else if (abs(O2U2X-C2U3X)<5 && abs(O2U2Y-C2U3Y)<5  && O2U2bond==false && C2U3bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O2U2X, O2U2Y, 10, 10);
    O2U2bond=true;
    C2U3bond=true;
  } else if (abs(O2U2X-C2U4X)<5 && abs(O2U2Y-C2U4Y)<5  && O2U2bond==false && C2U4bond==false) {
    fill(255, 255, 0);
    noStroke();
    ellipse(O2U2X, O2U2Y, 10, 10);
    O2U2bond=true;
    C2U4bond=true;
  }
}  //end of OCbond

void mouseReleased() {
  //腕の回転表示
  if (abs(O1U1X-O1U2X)<5 && abs(O1U1Y-O1U2Y)<5) {  //O1U12
    angle = O1U1angle;
    O1U1angle=angle + PI/36;
    O1U2angle=angle - PI/36;
    O1U1X = O1X + 40*cos(O1U1angle);
    O1U1Y = O1Y + 40*sin(O1U1angle); 
    O1U2X = O1X + 40*cos(O1U2angle);
    O1U2Y = O1Y + 40*sin(O1U2angle);
  }

  if (abs(O2U1X-O2U2X)<5 && abs(O2U1Y-O2U2Y)<5) {  //O2U12
    angle=O2U1angle ;
    O2U1angle=angle + PI/36;
    O2U2angle=angle - PI/36;
    O2U1X = O2X + 40*cos(O2U1angle);
    O2U1Y = O2Y + 40*sin(O2U1angle); 
    O2U2X = O2X + 40*cos(O2U2angle);
    O2U2Y = O2Y + 40*sin(O2U2angle);
  }

  if (abs(N1U1X-N1U2X)<5 && abs(N1U1Y-N1U2Y)<5) {  //N1U12
    angle=N1U1angle;
    N1U1angle=angle + PI/36;
    N1U2angle=angle - PI/36;
    N1U1X = N1X + 40*cos(N1U1angle);
    N1U1Y = N1Y + 40*sin(N1U1angle); 
    N1U2X = N1X + 40*cos(N1U2angle);
    N1U2Y = N1Y + 40*sin(N1U2angle);
  }

  if (abs(N1U1X-N1U3X)<5 && abs(N1U1Y-N1U3Y)<5) {  //N1U13
    angle=N1U1angle ;
    N1U1angle=angle + PI/36;
    N1U3angle=angle - PI/36;
    N1U1X = N1X + 40*cos(N1U1angle);
    N1U1Y = N1Y + 40*sin(N1U1angle); 
    N1U3X = N1X + 40*cos(N1U3angle);
    N1U3Y = N1Y + 40*sin(N1U3angle);
  }
  if (abs(N1U2X-N1U3X)<5 && abs(N1U2Y-N1U3Y)<5) {  //N1U23
    angle=N1U2angle;
    N1U2angle=angle + PI/36;
    N1U3angle=angle - PI/36;
    N1U2X = N1X + 40*cos(N1U2angle);
    N1U2Y = N1Y + 40*sin(N1U2angle); 
    N1U3X = N1X + 40*cos(N1U3angle);
    N1U3Y = N1Y + 40*sin(N1U3angle);
  }
  if (abs(N1U1X-N1U2X)<12 && abs(N1U1Y-N1U2Y)<12 && abs(N1U1X-N1U3X)<12 && abs(N1U1Y-N1U3Y)<12 && 
    abs(N1U2X-N1U3X)<10 && abs(N1U2Y-N1U3Y)<10) {  //N1U123
    angle=N1U1angle;
    N1U2angle=angle + PI/18;
    N1U3angle=angle - PI/18;
    N1U1X = N1X + 40*cos(angle);
    N1U1Y = N1Y + 40*sin(angle);
    N1U2X = N1X + 40*cos(N1U2angle);
    N1U2Y = N1Y + 40*sin(N1U2angle); 
    N1U3X = N1X + 40*cos(N1U3angle);
    N1U3Y = N1Y + 40*sin(N1U3angle);
  }
  if (abs(N2U1X-N2U2X)<5 && abs(N2U1Y-N2U2Y)<5) {  //N2U12
    angle=N2U1angle;
    N2U1angle=angle + PI/36;
    N2U2angle=angle - PI/36;
    N2U1X = N2X + 40*cos(N2U1angle);
    N2U1Y = N2Y + 40*sin(N2U1angle); 
    N2U2X = N2X + 40*cos(N2U2angle);
    N2U2Y = N2Y + 40*sin(N2U2angle);
  }
  if (abs(N2U1X-N2U3X)<5 && abs(N2U1Y-N2U3Y)<5) {  //N2U13
    angle=N2U1angle;
    N2U1angle=angle + PI/36;
    N2U3angle=angle - PI/36;
    N2U1X = N2X + 40*cos(N2U1angle);
    N2U1Y = N2Y + 40*sin(N2U1angle); 
    N2U3X = N2X + 40*cos(N2U3angle);
    N2U3Y = N2Y + 40*sin(N2U3angle);
  }
  if (abs(N2U2X-N2U3X)<5 && abs(N2U2Y-N2U3Y)<5) {  //N2U23
    angle=N2U2angle;
    N2U2angle=angle + PI/36;
    N2U3angle=angle - PI/36;
    N2U2X = N2X + 40*cos(N2U2angle);
    N2U2Y = N2Y + 40*sin(N2U2angle); 
    N2U3X = N2X + 40*cos(N2U3angle);
    N2U3Y = N2Y + 40*sin(N2U3angle);
  }
  if (abs(N2U1X-N2U2X)<12 && abs(N2U1Y-N2U2Y)<12 && abs(N2U1X-N2U3X)<12 && abs(N2U1Y-N2U3Y)<12 && 
    abs(N2U2X-N2U3X)<12 && abs(N2U2Y-N2U3Y)<12) {  //N2U123
    angle=N2U1angle;
    N2U2angle=angle + PI/18;
    N2U3angle=angle - PI/18;
    N2U1X = N2X + 40*cos(angle);
    N2U1Y = N2Y + 40*sin(angle);
    N2U2X = N2X + 40*cos(N2U2angle);
    N2U2Y = N2Y + 40*sin(N2U2angle); 
    N2U3X = N2X + 40*cos(N2U3angle);
    N2U3Y = N2Y + 40*sin(N2U3angle);
  }
  if (abs(C1U1X-C1U2X)<5 && abs(C1U1Y-C1U2Y)<5) {  //C1U12
    angle=C1U1angle;
    C1U1angle=angle + PI/36;
    C1U2angle=angle - PI/36;
    C1U1X = C1X + 40*cos(C1U1angle);
    C1U1Y = C1Y + 40*sin(C1U1angle); 
    C1U2X = C1X + 40*cos(C1U2angle);
    C1U2Y = C1Y + 40*sin(C1U2angle);
  }
  if (abs(C1U1X-C1U3X)<5 && abs(C1U1Y-C1U3Y)<5) {  //C1U13
    angle=C1U1angle ;
    C1U1angle=angle + PI/36;
    C1U3angle=angle - PI/36;
    C1U1X = C1X + 40*cos(C1U1angle);
    C1U1Y = C1Y + 40*sin(C1U1angle); 
    C1U3X = C1X + 40*cos(C1U3angle);
    C1U3Y = C1Y + 40*sin(C1U3angle);
  } 
  if (abs(C1U1X-C1U4X)<5 && abs(C1U1Y-C1U4Y)<5) {  //C1U14
    angle=C1U1angle ;
    C1U1angle=angle + PI/36;
    C1U4angle=angle - PI/36;
    C1U1X = C1X + 40*cos(C1U1angle);
    C1U1Y = C1Y + 40*sin(C1U1angle); 
    C1U4X = C1X + 40*cos(C1U4angle);
    C1U4Y = C1Y + 40*sin(C1U4angle);
  }
  if (abs(C1U2X-C1U3X)<5 && abs(C1U2Y-C1U3Y)<5) {  //C1U23
    angle=C1U2angle ;
    C1U2angle=angle + PI/36;
    C1U3angle=angle - PI/36;
    C1U2X = C1X + 40*cos(C1U2angle);
    C1U2Y = C1Y + 40*sin(C1U2angle); 
    C1U3X = C1X + 40*cos(C1U3angle);
    C1U3Y = C1Y + 40*sin(C1U3angle);
  }
  if (abs(C1U2X-C1U4X)<5 && abs(C1U2Y-C1U4Y)<5) {  //C1U24
    angle=C1U2angle;
    C1U2angle=angle + PI/36;
    C1U4angle=angle - PI/36;
    C1U2X = C1X + 40*cos(C1U2angle);
    C1U2Y = C1Y + 40*sin(C1U2angle); 
    C1U4X = C1X + 40*cos(C1U4angle);
    C1U4Y = C1Y + 40*sin(C1U4angle);
  }
  if (abs(C1U3X-C1U4X)<5 && abs(C1U3Y-C1U4Y)<5) {  //C1U34
    angle=C1U3angle;
    C1U3angle=angle + PI/36;
    C1U4angle=angle - PI/36;
    C1U3X = C1X + 40*cos(C1U3angle);
    C1U3Y = C1Y + 40*sin(C1U3angle); 
    C1U4X = C1X + 40*cos(C1U4angle);
    C1U4Y = C1Y + 40*sin(C1U4angle);
  }

  if (abs(C1U1X-C1U2X)<12 && abs(C1U1Y-C1U2Y)<12 && abs(C1U1X-C1U3X)<12 && abs(C1U1Y-C1U3Y)<12 && 
    abs(C1U2X-C1U3X)<12 && abs(C1U2Y-C1U3Y)<12) {  //C1U123
    angle=C1U1angle;
    C1U2angle=angle + PI/18;
    C1U3angle=angle - PI/18;
    C1U1X = C1X + 40*cos(angle);
    C1U1Y = C1Y + 40*sin(angle);
    C1U2X = C1X + 40*cos(C1U2angle);
    C1U2Y = C1Y + 40*sin(C1U2angle); 
    C1U3X = C1X + 40*cos(C1U3angle);
    C1U3Y = C1Y + 40*sin(C1U3angle);
  }  
  if (abs(C1U1X-C1U2X)<12 && abs(C1U1Y-C1U2Y)<12 && abs(C1U1X-C1U4X)<12 && abs(C1U1Y-C1U4Y)<12 && 
    abs(C1U2X-C1U4X)<12 && abs(C1U2Y-C1U4Y)<12) {  //C1U124
    angle=C1U1angle;
    C1U2angle=angle + PI/18;
    C1U4angle=angle - PI/18;
    C1U1X = C1X + 40*cos(angle);
    C1U1Y = C1Y + 40*sin(angle);
    C1U2X = C1X + 40*cos(C1U2angle);
    C1U2Y = C1Y + 40*sin(C1U2angle); 
    C1U4X = C1X + 40*cos(C1U4angle);
    C1U4Y = C1Y + 40*sin(C1U4angle);
  }  
  if (abs(C1U1X-C1U3X)<12 && abs(C1U1Y-C1U3Y)<12 && abs(C1U1X-C1U4X)<12 && abs(C1U1Y-C1U4Y)<12 && 
    abs(C1U3X-C1U4X)<12 && abs(C1U3Y-C1U4Y)<12) {  //C1U134
    angle=C1U1angle;
    C1U3angle=angle + PI/18;
    C1U4angle=angle - PI/18;
    C1U1X = C1X + 40*cos(angle);
    C1U1Y = C1Y + 40*sin(angle);
    C1U3X = C1X + 40*cos(C1U3angle);
    C1U3Y = C1Y + 40*sin(C1U3angle); 
    C1U4X = C1X + 40*cos(C1U4angle);
    C1U4Y = C1Y + 40*sin(C1U4angle);
  }  
  if (abs(C1U2X-C1U3X)<12 && abs(C1U2Y-C1U3Y)<12 && abs(C1U2X-C1U4X)<12 && abs(C1U2Y-C1U4Y)<12 && 
    abs(C1U3X-C1U4X)<12 && abs(C1U3Y-C1U4Y)<12) {  //C1U234
    angle=C1U2angle;
    C1U3angle=angle + PI/18;
    C1U4angle=angle - PI/18;
    C1U2X = C1X + 40*cos(angle);
    C1U2Y = C1Y + 40*sin(angle);
    C1U3X = C1X + 40*cos(C1U3angle);
    C1U3Y = C1Y + 40*sin(C1U3angle); 
    C1U4X = C1X + 40*cos(C1U4angle);
    C1U4Y = C1Y + 40*sin(C1U4angle);
  }  
  if (abs(C2U1X-C2U2X)<5 && abs(C2U1Y-C2U2Y)<5) {  //C2U12
    angle=C2U1angle;
    C2U1angle=angle + PI/36;
    C2U2angle=angle - PI/36;
    C2U1X = C2X + 40*cos(C2U1angle);
    C2U1Y = C2Y + 40*sin(C2U1angle); 
    C2U2X = C2X + 40*cos(C2U2angle);
    C2U2Y = C2Y + 40*sin(C2U2angle);
  }
  if (abs(C2U1X-C2U3X)<5 && abs(C2U1Y-C2U3Y)<5) {  //C2U13
    angle=C2U1angle;
    C2U1angle=angle + PI/36;
    C2U3angle=angle - PI/36;
    C2U1X = C2X + 40*cos(C2U1angle);
    C2U1Y = C2Y + 40*sin(C2U1angle); 
    C2U3X = C2X + 40*cos(C2U3angle);
    C2U3Y = C2Y + 40*sin(C2U3angle);
  } 
  if (abs(C2U1X-C2U4X)<5 && abs(C2U1Y-C2U4Y)<5) {  //C2U14
    angle=C2U1angle;
    C2U1angle=angle + PI/36;
    C2U4angle=angle - PI/36;
    C2U1X = C2X + 40*cos(C2U1angle);
    C2U1Y = C2Y + 40*sin(C2U1angle); 
    C2U4X = C2X + 40*cos(C2U4angle);
    C2U4Y = C2Y + 40*sin(C2U4angle);
  }
  if (abs(C2U2X-C2U3X)<5 && abs(C2U2Y-C2U3Y)<5) {  //C2U23
    angle=C2U2angle;
    C2U2angle=angle + PI/36;
    C2U3angle=angle - PI/36;
    C2U2X = C2X + 40*cos(C2U2angle);
    C2U2Y = C2Y + 40*sin(C2U2angle); 
    C2U3X = C2X + 40*cos(C2U3angle);
    C2U3Y = C2Y + 40*sin(C2U3angle);
  }
  if (abs(C2U2X-C2U4X)<5 && abs(C2U2Y-C2U4Y)<5) {  //C2U24
    angle=C2U2angle;
    C2U2angle=angle + PI/36;
    C2U4angle=angle - PI/36;
    C2U2X = C2X + 40*cos(C2U2angle);
    C2U2Y = C2Y + 40*sin(C2U2angle); 
    C2U4X = C2X + 40*cos(C2U4angle);
    C2U4Y = C2Y + 40*sin(C2U4angle);
  }
  if (abs(C2U3X-C2U4X)<5 && abs(C2U3Y-C2U4Y)<5) {  //C2U34
    angle=C2U3angle;
    C2U3angle=angle + PI/36;
    C2U4angle=angle - PI/36;
    C2U3X = C2X + 40*cos(C2U3angle);
    C2U3Y = C2Y + 40*sin(C2U3angle); 
    C2U4X = C2X + 40*cos(C2U4angle);
    C2U4Y = C2Y + 40*sin(C2U4angle);
  }

  if (abs(C2U1X-C2U2X)<12 && abs(C2U1Y-C2U2Y)<12 && abs(C2U1X-C2U3X)<12 && abs(C2U1Y-C2U3Y)<12 && 
    abs(C2U2X-C2U3X)<12 && abs(C2U2Y-C2U3Y)<12) {  //C2U123
    angle=C2U1angle ;
    C2U2angle=angle + PI/18;
    C2U3angle=angle - PI/18;
    C2U1X = C2X + 40*cos(angle);
    C2U1Y = C2Y + 40*sin(angle);
    C2U2X = C2X + 40*cos(C2U2angle);
    C2U2Y = C2Y + 40*sin(C2U2angle); 
    C2U3X = C2X + 40*cos(C2U3angle);
    C2U3Y = C2Y + 40*sin(C2U3angle);
  }  
  if (abs(C2U1X-C2U2X)<12 && abs(C2U1Y-C2U2Y)<12 && abs(C2U1X-C2U4X)<12 && abs(C2U1Y-C2U4Y)<12 && 
    abs(C2U2X-C2U4X)<12 && abs(C2U2Y-C2U4Y)<12) {  //C2U124
    angle=C2U1angle ;
    C2U2angle=angle + PI/18;
    C2U4angle=angle - PI/18;
    C2U1X = C2X + 40*cos(angle);
    C2U1Y = C2Y + 40*sin(angle);
    C2U2X = C2X + 40*cos(C2U2angle);
    C2U2Y = C2Y + 40*sin(C2U2angle); 
    C2U4X = C2X + 40*cos(C2U4angle);
    C2U4Y = C2Y + 40*sin(C2U4angle);
  }  
  if (abs(C2U1X-C2U3X)<12 && abs(C2U1Y-C2U3Y)<12 && abs(C2U1X-C2U4X)<12 && abs(C2U1Y-C2U4Y)<12 && 
    abs(C2U3X-C2U4X)<12 && abs(C2U3Y-C2U4Y)<12) {  //C2U134
    angle=C2U1angle;
    C2U3angle=angle + PI/18;
    C2U4angle=angle - PI/18;
    C2U1X = C2X + 40*cos(angle);
    C2U1Y = C2Y + 40*sin(angle);
    C2U3X = C2X + 40*cos(C2U3angle);
    C2U3Y = C2Y + 40*sin(C2U3angle); 
    C2U4X = C2X + 40*cos(C2U4angle);
    C2U4Y = C2Y + 40*sin(C2U4angle);
  }  
  if (abs(C2U2X-C2U3X)<12 && abs(C2U2Y-C2U3Y)<12 && abs(C2U2X-C2U4X)<12 && abs(C2U2Y-C2U4Y)<12 && 
    abs(C2U3X-C2U4X)<12 && abs(C2U3Y-C2U4Y)<12) {  //C2U234
    angle=C2U2angle;
    C2U3angle=angle + PI/18;
    C2U4angle=angle - PI/18;
    C2U2X = C2X + 40*cos(angle);
    C2U2Y = C2Y + 40*sin(angle);
    C2U3X = C2X + 40*cos(C2U3angle);
    C2U3Y = C2Y + 40*sin(C2U3angle); 
    C2U4X = C2X + 40*cos(C2U4angle);
    C2U4Y = C2Y + 40*sin(C2U4angle);
  }
}  //end of mouseReleased


//ポインターの形を状況に応じて変える
void hand() {
  if (mouseX>H1X-5 && mouseX<H1X+5 && mouseY>H1Y-5 && mouseY<H1Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>H1X-5 && mouseX<H1X+5 && mouseY>H1Y-5 && mouseY<H1Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>H1U1X-5 && mouseX<H1U1X+5 && mouseY>H1U1Y-5 && mouseY<H1U1Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>H1U1X-5 && mouseX<H1U1X+5 && mouseY>H1U1Y-5 && mouseY<H1U1Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>H2X-5 && mouseX<H2X+5 && mouseY>H2Y-5 && mouseY<H2Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>H2X-5 && mouseX<H2X+5 && mouseY>H2Y-5 && mouseY<H2Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>H2U1X-5 && mouseX<H2U1X+5 && mouseY>H2U1Y-5 && mouseY<H2U1Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>H2U1X-5 && mouseX<H2U1X+5 && mouseY>H2U1Y-5 && mouseY<H2U1Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>H3X-5 && mouseX<H3X+5 && mouseY>H3Y-5 && mouseY<H3Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>H3X-5 && mouseX<H3X+5 && mouseY>H3Y-5 && mouseY<H3Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>H3U1X-5 && mouseX<H3U1X+5 && mouseY>H3U1Y-5 && mouseY<H3U1Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>H3U1X-5 && mouseX<H3U1X+5 && mouseY>H3U1Y-5 && mouseY<H3U1Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>H4X-5 && mouseX<H4X+5 && mouseY>H4Y-5 && mouseY<H4Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>H4X-5 && mouseX<H4X+5 && mouseY>H4Y-5 && mouseY<H4Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>H4U1X-5 && mouseX<H4U1X+5 && mouseY>H4U1Y-5 && mouseY<H4U1Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>H4U1X-5 && mouseX<H4U1X+5 && mouseY>H4U1Y-5 && mouseY<H4U1Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>H5X-5 && mouseX<H5X+5 && mouseY>H5Y-5 && mouseY<H5Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>H5X-5 && mouseX<H5X+5 && mouseY>H5Y-5 && mouseY<H5Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>H5U1X-5 && mouseX<H5U1X+5 && mouseY>H5U1Y-5 && mouseY<H5U1Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>H5U1X-5 && mouseX<H5U1X+5 && mouseY>H5U1Y-5 && mouseY<H5U1Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>H6X-5 && mouseX<H6X+5 && mouseY>H6Y-5 && mouseY<H6Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>H6X-5 && mouseX<H6X+5 && mouseY>H6Y-5 && mouseY<H6Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>H6U1X-5 && mouseX<H6U1X+5 && mouseY>H6U1Y-5 && mouseY<H6U1Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>H6U1X-5 && mouseX<H6U1X+5 && mouseY>H6U1Y-5 && mouseY<H6U1Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>O1X-5 && mouseX<O1X+5 && mouseY>O1Y-5 && mouseY<O1Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>O1X-5 && mouseX<O1X+5 && mouseY>O1Y-5 && mouseY<O1Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>O1U1X-5 && mouseX<O1U1X+5 && mouseY>O1U1Y-5 && mouseY<O1U1Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>O1U1X-5 && mouseX<O1U1X+5 && mouseY>O1U1Y-5 && mouseY<O1U1Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>O1U2X-5 && mouseX<O1U2X+5 && mouseY>O1U2Y-5 && mouseY<O1U2Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>O1U2X-5 && mouseX<O1U2X+5 && mouseY>O1U2Y-5 && mouseY<O1U2Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>O2X-5 && mouseX<O2X+5 && mouseY>O2Y-5 && mouseY<O2Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>O2X-5 && mouseX<O2X+5 && mouseY>O2Y-5 && mouseY<O2Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>O2U1X-5 && mouseX<O2U1X+5 && mouseY>O2U1Y-5 && mouseY<O2U1Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>O2U1X-5 && mouseX<O2U1X+5 && mouseY>O2U1Y-5 && mouseY<O2U1Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>O2U2X-5 && mouseX<O2U2X+5 && mouseY>O2U2Y-5 && mouseY<O2U2Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>O2U2X-5 && mouseX<O2U2X+5 && mouseY>O2U2Y-5 && mouseY<O2U2Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>N1X-5 && mouseX<N1X+5 && mouseY>N1Y-5 && mouseY<N1Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>N1X-5 && mouseX<N1X+5 && mouseY>N1Y-5 && mouseY<N1Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>N1U1X-5 && mouseX<N1U1X+5 && mouseY>N1U1Y-5 && mouseY<N1U1Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>N1U1X-5 && mouseX<N1U1X+5 && mouseY>N1U1Y-5 && mouseY<N1U1Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>N1U2X-5 && mouseX<N1U2X+5 && mouseY>N1U2Y-5 && mouseY<N1U2Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>N1U2X-5 && mouseX<N1U2X+5 && mouseY>N1U2Y-5 && mouseY<N1U2Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>N1U3X-5 && mouseX<N1U3X+5 && mouseY>N1U3Y-5 && mouseY<N1U3Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>N1U3X-5 && mouseX<N1U3X+5 && mouseY>N1U3Y-5 && mouseY<N1U3Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>N2X-5 && mouseX<N2X+5 && mouseY>N2Y-5 && mouseY<N2Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>N2X-5 && mouseX<N2X+5 && mouseY>N2Y-5 && mouseY<N2Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>N2U1X-5 && mouseX<N2U1X+5 && mouseY>N2U1Y-5 && mouseY<N2U1Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>N2U1X-5 && mouseX<N2U1X+5 && mouseY>N2U1Y-5 && mouseY<N2U1Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>N2U2X-5 && mouseX<N2U2X+5 && mouseY>N2U2Y-5 && mouseY<N2U2Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>N2U2X-5 && mouseX<N2U2X+5 && mouseY>N2U2Y-5 && mouseY<N2U2Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>N2U3X-5 && mouseX<N2U3X+5 && mouseY>N2U3Y-5 && mouseY<N2U3Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>N2U3X-5 && mouseX<N2U3X+5 && mouseY>N2U3Y-5 && mouseY<N2U3Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>C1X-5 && mouseX<C1X+5 && mouseY>C1Y-5 && mouseY<C1Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>C1X-5 && mouseX<C1X+5 && mouseY>C1Y-5 && mouseY<C1Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>C1U1X-5 && mouseX<C1U1X+5 && mouseY>C1U1Y-5 && mouseY<C1U1Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>C1U1X-5 && mouseX<C1U1X+5 && mouseY>C1U1Y-5 && mouseY<C1U1Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>C1U2X-5 && mouseX<C1U2X+5 && mouseY>C1U2Y-5 && mouseY<C1U2Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>C1U2X-5 && mouseX<C1U2X+5 && mouseY>C1U2Y-5 && mouseY<C1U2Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>C1U3X-5 && mouseX<C1U3X+5 && mouseY>C1U3Y-5 && mouseY<C1U3Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>C1U3X-5 && mouseX<C1U3X+5 && mouseY>C1U3Y-5 && mouseY<C1U3Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>C1U4X-5 && mouseX<C1U4X+5 && mouseY>C1U4Y-5 && mouseY<C1U4Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>C1U4X-5 && mouseX<C1U4X+5 && mouseY>C1U4Y-5 && mouseY<C1U4Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>C2X-5 && mouseX<C2X+5 && mouseY>C2Y-5 && mouseY<C2Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>C2X-5 && mouseX<C2X+5 && mouseY>C2Y-5 && mouseY<C2Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>C2U1X-5 && mouseX<C2U1X+5 && mouseY>C2U1Y-5 && mouseY<C2U1Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>C2U1X-5 && mouseX<C2U1X+5 && mouseY>C2U1Y-5 && mouseY<C2U1Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>C2U2X-5 && mouseX<C2U2X+5 && mouseY>C2U2Y-5 && mouseY<C2U2Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>C2U2X-5 && mouseX<C2U2X+5 && mouseY>C2U2Y-5 && mouseY<C2U2Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>C2U3X-5 && mouseX<C2U3X+5 && mouseY>C2U3Y-5 && mouseY<C2U3Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>C2U3X-5 && mouseX<C2U3X+5 && mouseY>C2U3Y-5 && mouseY<C2U3Y+5 && mousePressed==true) {
    cursor(HAND);
  } else if (mouseX>C2U4X-5 && mouseX<C2U4X+5 && mouseY>C2U4Y-5 && mouseY<C2U4Y+5 && mousePressed==false) {
    cursor(CROSS);
  } else if (mouseX>C2U4X-5 && mouseX<C2U4X+5 && mouseY>C2U4Y-5 && mouseY<C2U4Y+5 && mousePressed==true) {
    cursor(HAND);
  } else {
    cursor(ARROW);
  }
}  //end of hand

void button() {
  //トライ番号選択ボタン
  textFont(fontG12); 
  fill(255, 255, 255); 
  text("ボタンを押して", 464, 20); 
  text("問題を選択する", 464, 35); 
  text("（緑色は完成済）", 460, 55); 
  stroke(150, 150, 150);
  strokeWeight(1);
  line(470, 70, 470, 320); 
  line(470, 70, 540, 70);
  line(540, 70, 540, 320);
  line(470, 320, 540, 320);

  fill(255, 255, 255);
  noStroke();
  for (int i=0; i<13; i++) {
    ellipse(510, 298-17*i, 20, 14);
  }
  for (int i=0; i<12; i++) {
    textFont(fontG12);   
    text(12-i, 480, 94+17*i+5);
  }
  text("S", 480, 94+17*12+5);

  fill(255, 0, 0);
  noStroke();
  if (try0==true) {
    ellipse(510, 298-17*0, 20, 14);
  } else if (try1==true) {
    ellipse(510, 298-17*1, 20, 14);
  } else if (try2==true) {
    ellipse(510, 298-17*2, 20, 14);
  } else if (try3==true) {
    ellipse(510, 298-17*3, 20, 14);
  } else if (try4==true) {
    ellipse(510, 298-17*4, 20, 14);
  } else if (try5==true) {
    ellipse(510, 298-17*5, 20, 14);
  } else if (try6==true) {
    ellipse(510, 298-17*6, 20, 14);
  } else if (try7==true) {
    ellipse(510, 298-17*7, 20, 14);
  } else if (try8==true) {
    ellipse(510, 298-17*8, 20, 14);
  } else if (try9==true) {
    ellipse(510, 298-17*9, 20, 14);
  } else if (try10==true) {
    ellipse(510, 298-17*10, 20, 14);
  } else if (try11==true) {
    ellipse(510, 298-17*11, 20, 14);
  } else if (try12==true) {
    ellipse(510, 298-17*12, 20, 14);
  } 
  //tryOK
  fill(0, 255, 0);
  noStroke();
  if (try1OK==true) {
    ellipse(510, 298-17*1, 20, 14);
  }
  if (try2OK==true) {
    ellipse(510, 298-17*2, 20, 14);
  }
  if (try3OK==true) {
    ellipse(510, 298-17*3, 20, 14);
  }
  if (try4OK==true) {
    ellipse(510, 298-17*4, 20, 14);
  }
  if (try5OK==true) {
    ellipse(510, 298-17*5, 20, 14);
  }
  if (try6OK==true) {
    ellipse(510, 298-17*6, 20, 14);
  }
  if (try7OK==true) {
    ellipse(510, 298-17*7, 20, 14);
  }
  if (try8OK==true) {
    ellipse(510, 298-17*8, 20, 14);
  }
  if (try9OK==true) {
    ellipse(510, 298-17*9, 20, 14);
  }
  if (try10OK==true) {
    ellipse(510, 298-17*10, 20, 14);
  }
  if (try11OK==true) {
    ellipse(510, 298-17*11, 20, 14);
  }
  if (try12OK==true) {
    ellipse(510, 298-17*12, 20, 14);
  }
}  //end of button

//<A>,<Z>ボタン  
void AZkey() { 
  if (mouseX>25 && mouseX<60 && mouseY>640 && mouseY<675) {
    Akey=true;
  } else {
    Akey=false;
  }
  if (mouseX>25 && mouseX<60 && mouseY>680 && mouseY<715) {
    Zkey=true;
  } else {
    Zkey=false;
  }
  //<A>ボタン,<Z>ボタン表示  
  stroke(150, 150, 150);
  strokeWeight(1);
  fill(100, 100, 100);  
  if (Akey==true) {
    fill(150, 150, 150);
  }  
  rect(25, 640, 35, 35);

  fill(100, 100, 100);  
  if (Zkey==true) {
    fill(150, 150, 150);
  }  
  rect(25, 680, 35, 35);

  fill(0, 0, 0); 
  textFont(fontG18);   
  text("Ａ", 34, 665); 
  text("Ｚ", 34, 705);
}

//フォントサイズ変更
void changeFont() {
  if (i<30) {
    textFont(fontG18);
  } else {
    textFont(fontG25);
  }
}

